#!/usr/bin/env python

#from twisted.internet import reactor
from twisted.internet import selectreactor
selectreactor.install()

from twisted import version as twv
from twisted.internet import defer, protocol, reactor, address, utils
from twisted.internet import interfaces, process, fdesc
from twisted.internet import abstract, threads, task
from twisted.conch.ssh import transport, userauth, connection, common, keys, channel, forwarding, session
from twisted.conch.client import direct
from twisted.conch.insults import insults
from twisted.conch.manhole import Manhole
from twisted.conch.manhole_ssh import ConchFactory, TerminalRealm
from twisted.conch.stdio import ConsoleManhole
from twisted.conch.telnet import TelnetTransport, TelnetBootstrapProtocol
from twisted.application import service
from twisted.python import util, threadable, usage, failure
from twisted.python import log as logging
from twisted.python import usage, filepath
from twisted.spread import pb, jelly, flavors, banana, util
from twisted.cred.portal import IRealm, Portal
from twisted.cred.checkers import InMemoryUsernamePasswordDatabaseDontUse, AllowAnonymousAccess
from twisted.cred.credentials import UsernamePassword, Anonymous
from twisted.cred.credentials import IUsernamePassword, IAnonymous
from zope.interface import implements

import persistent
import netifaces
from types import *
from FunctionMarshal import *
import new

from sys import argv
import getpass, time, copy
import struct, sys, getpass, os, time, string
import fcntl
from random import choice,randint
import posix, socket, sets
from sets import Set
import cStringIO, cPickle, marshal, traceback
import pickle
import imp
import uuid

#import curses, curses.wrapper

from basics import verbsh,glob
import psutil
#from pympler.muppy import summary
#from pympler import tracker
#from pympler import refbrowser
#from pympler.asizeof import asizeof

from oldnumeric import argsort
from numpy import ndarray
from numpy.core.numerictypes import *
import numpy

cPickleTypes = [ndarray]

DEFAULTPORT = 8789
orig_path = copy.copy(sys.path)

#if sys.argv[0].split("/")[-1] not in ["TwistedServer"]:
#   USER = getpass.getuser()
#   PASSWORD = getpass.getpass("%s's password: " % (USER))

HOST = os.uname()[1]
en = "lo0"
for i in netifaces.interfaces():
  if 2 in netifaces.ifaddresses(i) and netifaces.ifaddresses(i)[2][0].has_key("broadcast"):
     en = i
en0 = netifaces.ifaddresses(en)
ipaddr = en0[2][0]["addr"]

global IMPORTS
IMPORTS = {}

TWDIR = os.environ.get("TWDIR","/tmp")
if not os.path.exists(TWDIR): os.mkdir(TWDIR)

if os.path.exists(".Twisted"):
   o = open(".Twisted","r")
   MACHINES = [str(l[:-1].strip()) for l in o.readlines() if l[0] != "#"]
   o.close()
elif os.environ.has_key('TWISTEDSERVERS'):
   MACHINES = os.environ['TWISTEDSERVERS'].split(",")
else:
   MACHINES = []

def twisted_import(name,comps=None,IMPORTS=IMPORTS,verb=0):
   fo,pn,desc = imp.find_module(name)
   mstat = os.stat(pn)
   if verb:
      print IMPORTS.keys()
      print "IS %s in IMPORTS?" % (name)
      print pn,pn in IMPORTS
   if pn not in IMPORTS or mstat != IMPORTS[pn][1]:
      mload = True
      print "LOADING MODULE:",pn
      modobj = imp.load_module(name,fo,pn,desc)
   else:
      mload = False
      modobj = IMPORTS[pn][0]
   if fo: fo.close()
   IMPORTS[pn] = (modobj,mstat)
   if comps == "*":
     s = "from %s import *" % (name)
     if mload: print s
     for k in dir(modobj):
         globals()[k] = getattr(modobj,k)
   elif comps:
     s = "from %s import %s" % (name,comps)
     if mload: print s
     for k in comps.split(","):
       globals()[k] = getattr(modobj,k)
   else:
     s = "import %s" % (name)
     if mload: print s
     globals()[name] = modobj
   if verb:
      print "Done with (re)import."
   sys.stdout.flush()
   return s


def rdarg(argv,key,conv=None,default=None,single=0):
   val = default
   if key in argv:
    if not single:
      val=argv[argv.index(key)+1]
      del argv[argv.index(key):argv.index(key)+2]
      if conv: val=map(conv,[val])[0]
    else:
      del argv[argv.index(key):argv.index(key)+1]
      val = 1
      if default == 1: val=0
   else:
      if conv and val: val=apply(conv,(val,))
   return argv,val

class SimpleTransport(transport.SSHClientTransport):
    def __init__(self,hub=None,user="",password="",host="",number=1,lport=0,verb=0,clean=0):
        self.hub = hub
        self.host = host
        self.number = number
        self.user = user
        self.password = password
        self.verb = verb
        self.clean = clean
        c = string.letters+string.digits
        self.user2 = "guest"
        self.password2 = "guest"
#        self.user2 = "".join([choice(c) for k in range(randint(10,20))])
#        self.password2 = "".join([choice(c) for k in range(randint(10,20))])
        self.lport = lport
    def verifyHostKey(self, hostKey, fingerprint):
        if self.verb: print 'host key fingerprint: %s' % fingerprint
        return defer.succeed(1) 
    def connectionSecure(self,number=0):
        if not number: number = self.number
        sc = SimpleConnection()
        self.sc = sc
        sc.transport = self
        sc.hub = self.hub
        sc.orighost = self.host
        sc.number = number
        sc.lport = self.lport
        sc.transport = self
        sc.user2 = self.user2
        sc.password2 = self.password2
        sc.verb = self.verb
        sc.clean = self.clean
        sua = SimpleUserAuth(self.user,sc)
        self.sua = sua
        sua.transport = self
        sua.tried = 0
        sua.password = self.password
        sua.verb = self.verb
        self.requestService(sua)

class SimpleClientFactory(protocol.ClientFactory):
    def __init__(self,hub=None,user="",password="",host="",number=1,lport=0,verb=0,clean=0):
        self.hub = hub
        self.host = host
        self.number = number
        self.user = user
        self.password = password
        self.lport = lport
        self.verb = verb
        self.clean = clean
    def buildProtocol(self,addr):
        p = self.protocol(hub=self.hub,user=self.user,password=self.password,host=self.host,number=self.number,lport=self.lport,verb=self.verb,clean=self.clean)
        self.p = p
        p.factory = self
        return p

class SimpleUserAuth(userauth.SSHUserAuthClient):
    def getPassword(self,prompt=None):
        print "Asking for password!"
        return defer.succeed(getpass.getpass("%s@%s's password: " % (USER, HOST)))
#        return defer.succeed(self.password)
    def getGenericAnswers(self, name, instruction, questions):
        if self.verb:
           print "Name",name
           print "Instruction",instruction
           print "Questions",questions
        answers = []
        self.tried += 1
        if self.tried > 4:
           print "We have a password problem!"
           reactor.callFromThread(reactor.disconnectAll)
           reactor.callFromThread(reactor.stop)
        for prompt, echo in questions:
            if prompt == "Password:" and self.password:
              answer = self.password
            else:
              if echo: 
                  answer = raw_input(prompt)
              else:
                  answer = getpass.getpass(prompt)
            answers.append(answer)
        return defer.succeed(answers)
    def getPublicKey(self):
        path = os.path.expanduser('~/.ssh/id_rsa') 
        # this works with rsa too
        # just change the name here and in getPrivateKey
        if not os.path.exists(path) or self.lastPublicKey:
            # the file doesn't exist, or we've tried a public key
            return
        return keys.Key.fromFile(filename=path+'.pub')
    def getPrivateKey(self):
        path = os.path.expanduser('~/.ssh/id_rsa')
        return defer.succeed(keys.Key.fromFile(path))

class SimpleConnection(connection.SSHConnection):
    def serviceStarted(self,number=0):
        if not number:
           self.localForwards = {}
           self.last = None
           self.chs = []
           number = self.number
        for j in range(number):
            ch1 = InitChannel()
            self.openChannel(ch1)
            self.chs.append(ch1)
            print j,len(self.chs),self.number,ch1
    def serviceStopped(self):
        for s in self.localForwards.keys():
            try:
                s.loseConnection()
                self.localForwards.pop(s)
            except: pass

class SSHListenClientForwardingChannel(forwarding.SSHListenClientForwardingChannel): pass

class InitChannel(channel.SSHChannel):
    name = "session"
    def openFailed(self, reason):
        sys.stdout.write("echo failed: %s\n" % (reason))

    def channelOpen(self, ignoredData):
        print self.conn.hub.added, self.conn.hub.added2, len(self.conn.hub.CONNECTORS)
        self.rport = 0
        self.rhost = "None"
        self.use = 0
        self.log = ""
        command = self.conn.hub.COMMAND
        sys.stdout.write(command+"\n")
        d = self.conn.sendRequest(self, 'exec', common.NS(command), wantReply = 0)
        self.conn.hub.STARTED.append(self.conn)
        self.uuid = uuid.UUID(bytes=os.urandom(16),version=4).int
        self.stdout = cStringIO.StringIO()
        self.stderr = cStringIO.StringIO()

#        d.addCallback(self._cbRequest)
#
#    def _cbRequest(self,ignored):
#        self.conn.hub2.added2 += 1
#        self.conn.hub.STARTED.apppend(self.conn)

    def closeReceived(self):
        if not self.conn.hub.clean and self in self.conn.hub.RUNNING:
            self.conn.hub.RUNNING.remove(self)
            if self in self.conn.hub.CONNECTORS:
                print "Popping %r out of CONNECTORS" % (self)
                c,r = self.conn.hub.CONNECTORS.pop(self)
                self.conn.number -= 1
                self.conn.transport.number -= 1
                self.conn.transport.factory.number -= 1
                if c.state == "connected": c.disconnect()
                if self in self.conn.hub.CONNECTORS2:
                   c2,r2 = self.conn.hub.CONNECTORS2.pop(self)
                   if c2.state == "connected": c2.disconnect()
                self.conn.hub.added -= 1
                self.conn.hub.added2 -= 1
            if self in self.conn.hub.TASKS:
                print "Popping %r out of TASKS" % (self)
                otasks = self.conn.hub.TASKS.pop(self)
                for otask in otasks:
                    print otask.taskid,cPickle.loads(otask.args)
                [delattr(otask,"assigned") for otask in otasks if hasattr(otask,"assigned")]
                [delattr(otask,"ahost") for otask in otasks if hasattr(otask,"ahost")]
                if not self.conn.hub.finish and not self.conn.hub.die:
                  self.conn.hub.tasks.extend(otasks)
            if not self.conn.hub.finish and not self.conn.hub.die:
                print "Open new one!"
                reactor.callLater(1,self.conn.hub.AddHost,self.rhost,1)

    def dataReceived(self, data):
        self.log = self.log + data
        if self.conn.verb:
           sys.stdout.write('Data from %s(%d):\n' % (self.rhost,self.rport))
           sys.stdout.write( data)
           sys.stdout.flush()
        self.conn.hub.out.write('Data from %s(%d):\n' % (self.rhost,self.rport))
        self.conn.hub.out.write( data)
        self.conn.hub.out.flush()
        self.stdout.write( data)
        self.stdout.flush( )
        data = data.split("\n")
        for line in data:
           if "DONE CLEANING" in line:
              self.conn.hub.RUNNING.append(self)
           elif "No longer running the reactor!" in line:
              self.loseConnection()
#              if self in self.conn.hub.RUNNING: self.conn.hub.RUNNING.remove(self)
           elif "THIS MACHINE IS" in line:
              line = line.strip().split()
              self.rhost = line[3]
              self.rhost = self.conn.orighost
              self.rhostip = line[4][1:-2]
              self.rhostop = line[6][:-1]
           elif "ENTER USERNAME" in line:
              self.write(self.conn.user2+"\n")
           elif "ENTER PASSWORD" in line:
              self.write(self.conn.password2+"\n")
           elif "SSH PORT" in line:
              line = line.strip().split("=")
              self.sport = int(line[1])
              if not (self.conn.hub.finish or self.conn.hub.die):
                    s = reactor.listenTCP(0,
                           forwarding.SSHListenForwardingFactory(self.conn,
                                   (self.rhostip,self.sport),
                                   SSHListenClientForwardingChannel))
                    self.sshlhost = os.uname()[1]
                    self.sshlport = s.getHost().port
                    self.stdout.close()
                    self.stderr.close()
                    self.stdoutn = "%s/%d-%s.out" % (TWDIR,self.sshlport,self.rhost)
                    self.stderrn = "%s/%d-%s.err" % (TWDIR,self.sshlport,self.rhost)
                    self.stdout = open(self.stdoutn,"w")
                    self.stderr = open(self.stderrn,"w")
                    self.conn.hub.ALLHOSTS.append(self)
                    if 1 or self.conn.verb:
                       text = "Forwarding ssh for local port %d to %s(%s) port %d\n" % (self.sshlport,self.rhost,self.rhostip,self.sport)
                       sys.stdout.write( text)
                    reactor.callFromThread(reactor.wakeUp)
                    s.startReading()
                    self.conn.localForwards.setdefault(s)
           elif "USING PORT" in line:
              line = line.strip().split("=")
              if len(line) == 2:
                 ports = line[1].split()
                 if len(ports) == 1:
                     if not (self.conn.hub.finish or self.conn.hub.die):
                        self.rport = int(line[1])
                        s = reactor.listenTCP(0,
                               forwarding.SSHListenForwardingFactory(self.conn,
                                       (self.rhostip,self.rport),
                                       SSHListenClientForwardingChannel))
                        self.lport = s.getHost().port
                        if 1 or self.conn.verb:
                           text = "Forwarding local port %d to %s(%s) port %d\n" % (self.lport,self.rhost,self.rhostip,self.rport)
                           sys.stdout.write( text)
                        reactor.callFromThread(reactor.wakeUp)
                        s.startReading()
                        self.conn.localForwards.setdefault(s)
                        self.conn.hub.conns.append(self.conn)
                        reactor.callLater(0.1,self.conn.hub.MakeConnector,self)
#                        self.conn.hub.added2 += 1
                        print self.conn.hub.added, self.conn.hub.added2
                 elif len(ports) == 2:
                     if not (self.conn.hub.finish or self.conn.hub.die):
                        self.rport,self.rport2 = map(int,ports)
                        s = reactor.listenTCP(0,
                               forwarding.SSHListenForwardingFactory(self.conn,
                                       (self.rhostip,self.rport),
                                       SSHListenClientForwardingChannel))
                        s2 = reactor.listenTCP(0,
                               forwarding.SSHListenForwardingFactory(self.conn,
                                       (self.rhostip,self.rport2),
                                       SSHListenClientForwardingChannel))
                        self.lport = s.getHost().port
                        self.lport2 = s2.getHost().port
                        if 1 or self.conn.verb:
                           text = "Forwarding local port %d to %s(%s) port %d\n" % (self.lport,self.rhost,self.rhostip,self.rport)
                           text = "Forwarding local port %d to %s(%s) port %d\n" % (self.lport2,self.rhost,self.rhostip,self.rport2)
                           sys.stdout.write( text)
                        reactor.callFromThread(reactor.wakeUp)
                        s.startReading()
                        s2.startReading()
                        self.conn.localForwards.setdefault(s)
                        self.conn.localForwards.setdefault(s2)
                        self.conn.hub.conns.append(self.conn)
                        reactor.callLater(0.1,self.conn.hub.MakeConnector,self)
                        print self.conn.hub.added, self.conn.hub.added2


    def extReceived(self, dataType, data):
        self.log = self.log + data
        text = 'extData from %s(%d):\n' % (self.rhost,self.rport)
        sys.stdout.write( text)
        sys.stdout.write( data)
        sys.stdout.flush()
        self.conn.hub.err.write( text)
        self.conn.hub.err.write( data)
        self.conn.hub.err.flush()
        self.stderr.write( data)
        self.stderr.flush( )
#        self.loseConnection()
#        if self in self.conn.hub.RUNNING: self.conn.hub.RUNNING.remove(self)

    def closed(self):
        self.loseConnection()
        self.stderr.close()
        self.stdout.close()
        print "Closed!"
#        if self in self.conn.hub.RUNNING: self.conn.hub.RUNNING.remove(self)

cwd = os.getcwd()
scwd = cwd.split("/")
op,host = os.uname()[:2]
#if op == "Darwin":
#   if scwd[1] == "Users":
#      scwd[1] = "home/%s" % (host.split(".")[0])
#      cwd = "/".join(scwd)
#   elif scwd[1] == "Volumes":
#      scwd[1:3] = [scwd[2],host.split(".")[0]]
#      cwd = "/".join(scwd)

class TwistedTask(persistent.Persistent,flavors.Copyable):
   def __init__(self,taskid=0,func=None,*args,**kws):
       self.elements = "taskid","func","args","kws","dargs","modules","fmodules","path","env","done","ohost","port","host","station","hole","ntasks","local","now"
       if taskid == -1:
          u = uuid.UUID(bytes=os.urandom(16),version=4)
          taskid = u.int
       self.taskid = taskid
       self.ohost = None
       self.local = False
       self.now = False
       self.port = -1
       if "path" in kws:
          self.path = kws["path"]
          kws.pop("path")
       else:
          self.path = os.getcwd()
       if "host" in kws:
          self.host = kws["host"]
          kws.pop("host")
       if "cleanup" in kws:
          self.cleanup = kws["cleanup"]
          kws.pop("cleanup")
       if "condition" in kws:
          self.setCondition(kws["condition"])
          kws.pop("condition")
#       if str(os.getpid()) not in str(taskid): print taskid
       if type(func) in [StringType]:
          self.func = func
          self.args = cPickle.dumps(args,2)
          self.kws = cPickle.dumps(kws,2)
       else:
          T = TransportFunction()
          self.func = {func.__name__:T.MarshalFunction(func)}
          self.args = marshal.dumps(T.Pack(args))
          self.kws = marshal.dumps(T.Pack(kws))
#          func2 = lambda : func(*args,**kws)
#          self.func = {func2.__name__:T.MarshalFunction(func2)}
#       self.args = [(type(a) in ftypes and T.FuncToDict(a)) or a for a in args]
#       self.kws = {}
#       [self.kws.setdefault(a,(type(kws[a]) in ftypes and T.FuncToDict(kws[a])) or kws[a]) for a in kws]
       self.dargs = False
       if "imported" in kws: self.imported = kws.pop("imported")
       else: self.imported = False
#       print "Do I have to dump the args?"
       if (len(self.args) + len(self.kws)) > 16384: self.dumpArgs()
       self.modules = []
       self.fmodules = []
       self.env = None
       self.done = False
   def __repr__(self):
       if type(self.func) is DictionaryType: name = self.func.keys()[0]
       else: name = self.func
       return "TwistedTask %r (%s:%d): %s / Done: %r" % (self.taskid,self.ohost,self.port,name,self.done)
   def dumpArgs(self):
#       print "Yes, I do!"
       if not os.path.exists("%s/.tasks" %(self.path)):
          os.mkdir("%s/.tasks" %(self.path))
       a = open("%s/.tasks/%dargs.dat" %(self.path,self.taskid),"wb")
       a.write(self.args)
       a.close()
#       print "Written",a.name
       a = open("%s/.tasks/%dkws.dat" %(self.path,self.taskid),"wb")
       a.write(self.kws)
       a.close()
#       print "Written",a.name
       self.dargs = True
       self.args = None
       self.kws = None
   def setPath(self,path):
       self.path = path
   def setEnv(self,env):
       self.env = cPickle.dumps(env,2)
   def setModules(self,modules):
       self.modules = modules
   def setFromModules(self,fmodules):
       self.fmodules = fmodules
#   def setResult(self,result):
#       print "in setResult",type(result),result[0] == "File"
#       if type(result) == TupleType and result[0] == "File":
##         a = open("%s/.tasks/%dargs.dat" %(self.path,self.taskid),"rb")
#         if os.path.exists(result[1]):
#            a = open(result[1],"rb")
#            result = a.read()
#            a.close()
#            os.remove(a.name)
#       self.result = result
#       self.done = True
   def setCondition(self,condition):
       self.condition = condition
   def getCondition(self):
       return self.condition()
   def longResult(self):
#       print "****"
#       print self.taskid,"in longResult",type(self.result[3]),self.result[3][0]
#       print "****"
       if type(self.result[3]) == TupleType and self.result[3][0] == "File":
#          print self.taskid,self.result[3][1], os.path.exists(self.result[3][1])
          if os.path.exists(self.result[3][1]):
             a = open(self.result[3][1],"rb")
#             if 1: print "Reading",a.name
             self.result[3] = cPickle.loads(a.read())
             a.close()
#             if 1: print "Removing",a.name
             os.remove(a.name)
   def CleanUp(self):
       if os.path.exists("%s/.tasks/%dargs.dat" %(self.path,self.taskid)):
          os.remove("%s/.tasks/%dargs.dat" %(self.path,self.taskid))
       if os.path.exists("%s/.tasks/%dkws.dat" %(self.path,self.taskid)):
          os.remove("%s/.tasks/%dkws.dat" %(self.path,self.taskid))
   def setResult(self,result):
       self.result = result
       self.done = True
#       if self.dargs:
#          if os.path.exists("%s/.%dargs.dat" %(self.path,self.taskid)):
#             os.remove("%s/.%dargs.dat" %(self.path,self.taskid))
#          if os.path.exists("%s/.%dkws.dat" %(self.path,self.taskid)):
#             os.remove("%s/.%dkws.dat" %(self.path,self.taskid))
   def uponReturn(self,fn,*args,**kw):
       self.uR = fn
       self.uRargs = args
       self.uRkw = kw

class CopyTask(flavors.Copyable):
   def __init__(self,taskid=0,func=None,*args,**kws):
       self.elements = "taskid","func","args","kws","dargs","modules","fmodules","path","env","done","ohost","port","host","station","hole","ntasks","local","now"
       self.taskid = taskid
       self.ohost = None
       self.local = False
       self.port = -1
       self.func = func
#       self.args = cPickle.dumps(args,2)
#       self.kws = cPickle.dumps(kws,2)
       self.modules = []
       self.fmodules = []
       self.dargs = False
       self.path = os.getcwd()
       self.env = None
       self.now = False
       self.done = False
       self.imported = False
   def __repr__(self):
       if type(self.func) is DictionaryType: name = self.func.keys()[0]
       else: name = self.func
       return "TwistedTask %r (%s:%d): %s / Done: %r" % (self.taskid,self.ohost,self.port,name,self.done)
   def setPath(self,path):
       self.path = path
   def setEnv(self,env):
       self.env = cPickle.dumps(env,2)
   def setModules(self,modules):
       self.modules = modules
   def setFromModules(self,fmodules):
       self.fmodules = fmodules
   def longResult(self):
       if not self.imported and type(self.result[3]) == TupleType and self.result[3][0] == "File":
          if os.path.exists(self.result[3][1]):
             a = open(self.result[3][1],"rb")
             print "CopyReading",a.name
             self.result[3] = cPickle.loads(a.read())
             a.close()
             os.remove(a.name)
   def setResult(self,result):
       self.result = result
       self.done = True

class ReceiverTask(flavors.RemoteCopy,TwistedTask):
     pass
pb.setUnjellyableForClass(CopyTask, ReceiverTask)

class EncapsulatedFunction():
    def __init__(self,func,hole=False):
       self.func = func
       self.code = getattr(func,"func_code",None)
       self.dict = getattr(func,"func_dict",{})
       self.globals = getattr(func,"func_globals",{})
       if hole and reactor.running:
          self.open()
    def run(self,*args,**kw):
       sys.stdout.flush()
       self.result = self.func(*args,**kw)
    def __call__(self,*args,**kw):
       if reactor.running:
          self.run(*args,**kw)
          return self.result
#          reactor.callInThread(self.run,*args,**kw)
#          d = threads.deferToThread( self.run,*args,**kw)
#          d.addCallback(lambda result: setattr(self,"result",result))
#          d.addErrback(lambda result: setattr(self,"result",result.getTraceback()))
#          print "Waiting for result now."
#          while not hasattr(self,"result"): time.sleep(1e-8)
#          return self.result
       else:
          self.run(*args,**kw)
          return self.result
    def __del__(self):
       self.close()
    def open(self):
       namespace = globals()
       namespace["self"] = self
       self.hole = AddManhole(getpass.getuser(),"",namespace,0)
       print "Opened manhole at",self.hole
    def close(self):
       if hasattr(self,"hole"):
          self.hole.stopListening()
          print "Closing manhole at",self.hole
          sys.stdout.flush()

def EvalTask(task): 
    if getattr(task,"env",None):
       newenviron = cPickle.loads(task.env)
       for item in newenviron:
           print "Loading new environment variable %s = %s" % (item,newenviron[item])
           os.environ[item] = newenviron[item]
    os.chdir(task.path)
#    if task.dargs and task.args == None and task.kws == None:
    if task.dargs:
       a = open("%s/.tasks/%dargs.dat" %(task.path,task.taskid),"r")
       task.args = a.read()
       a.close()
       a = open("%s/.tasks/%dkws.dat" %(task.path,task.taskid),"r")
       task.kws= a.read()
       a.close()
#       if os.path.exists("%s/.%dargs.dat" %(task.path,task.taskid)):
#          os.remove("%s/.%dargs.dat" %(task.path,task.taskid))
#       if os.path.exists("%s/.%dkws.dat" %(task.path,task.taskid)):
#          os.remove("%s/.%dkws.dat" %(task.path,task.taskid))
    if isinstance(task.func,DictionaryType):
       T = TransportFunction()
       func = task.func[ task.func.keys()[0]]
       name,func = T.UnmarshalFunction(func,globals())
       args = T.Unpack(marshal.loads(task.args),globals())
       kws = T.Unpack(marshal.loads(task.kws),globals())
    else:
       if hasattr(task,"modules"):
          [twisted_import(m) for m in task.modules if m]
       if hasattr(task,"fmodules"):
          [twisted_import(m,"*") for m in task.fmodules if m]
       func = eval(task.func)
       args = cPickle.loads(task.args)
       kws = cPickle.loads(task.kws)
    Efunc = EncapsulatedFunction(func,getattr(task,"hole",False))
    task.encapsulated = Efunc
    result = Efunc(*args,**kws)
    PackageResult(result,task)
    del Efunc
    return result
#    if isinstance(result,defer.Deferred):
#       result.addCallback(lambda result: task.setResult(result.result))
#       result.addCallback(lambda result: delattr(task,"encapsulated"))
#       result.addCallback(lambda result: setattr(task,"encapsulated",False))
#       return result
#    else:
#       if hasattr(task,"setResult"): task.setResult(result)
#       delattr(task,"encapsulated")
#       task.encapsulated = False
##       del Efunc
#       return result

def PackageResult(result,task):
    if hasattr(task,"setResult"): task.setResult(result)
    delattr(task,"encapsulated")
    task.encapsulated = False


class TwistedVerbSh(verbsh):
    def wait(self):
        while self.perf.poll() == None:
          time.sleep(0.01)
        return self.perf.poll()

class TestTask:
   def __init__(self):
      self.added = []
      self.fadded = []
      self.modules = []
      self.fmodules = []
   def perspective_lmod(self,smod):
         lmod = cPickle.loads(smod)
         os.chdir(lmod["path"])
         f = open(lmod["name"],"w")
         f.write(lmod["data"])
         f.close()
   def perspective_task(self,otask):
      tstart = time.time()
      print "Got",otask
      sys.stdout.flush()
      try:
         loadavg = os.getloadavg()
         if type(otask.func) is DictionaryType:
            T = TransportFunction()
            func = otask.func[ otask.func.keys()[0]]
            name,func = T.UnmarshalFunction(func,globals())
         else:
            func = otask.func
         taskid = otask.taskid
         sys.stdout.write("Function=%s\n" % (func))
         sys.stdout.flush()
         path = otask.path
         print "Changing current working directory to %s." % (path)
         sys.stdout.flush()
         os.chdir(path)
         sys.path = orig_path + [path]
         sys.stdout.flush()
#         if hasattr(otask,"env"):
#            newenviron = cPickle.loads(otask.env)
#            print "Loading environment variables."
#            for item in newenviron:
#                os.environ[item] = newenviron[item]
         if self.modules:
            [(twisted_import(m),self.added.append(m)) for m in self.modules if m and m not in self.added]
         if self.fmodules:
            [(twisted_import(m,"*"),self.fadded.append(m)) for m in self.fmodules if m and m not in self.fadded]
         if hasattr(otask,"modules"):
            [twisted_import(m) for m in otask.modules if m]
         if hasattr(otask,"fmodules"):
            [twisted_import(m,"*") for m in otask.fmodules if m]
         value = EvalTask(otask)
         value = cPickle.dumps(value,2)
         cPickled = True
         sys.stdout.write("Task %r completed.\n" % (taskid))
         sys.stdout.flush()
         success = True
      except:
         content = sys.stdout = sys.stderr = cStringIO.StringIO()
         traceback.print_exc()
         sys.stdout = sys.__stdout__
         sys.stderr = sys.__stderr__
         cPickled = False
         value = content.getvalue()
         sys.stderr.write(value)
         sys.stderr.flush()
         success = False
      if hasattr(otask,"cleanup"): eval(otask.cleanup)()
      tnow = time.time()
      telapse = tnow-tstart
      output = (loadavg,taskid,value,cPickled,success)
      return output



#    os.chdir(task.path)
#    return eval(task.func)(*cPickle.loads(task.args),**cPickle.loads(task.kws))

class HubRealm:
    implements(IRealm)
    def setHub(self,hub):
        self.hub = hub
        self.spawn = HubSpawn()
        self.spawn.setHub(self.hub)
    def requestAvatar(self, avatarId, mind, *interfaces):
        if pb.IPerspective in interfaces:
            return pb.IPerspective, self.spawn, lambda : None
        else:
            raise NotImplementedError("no interface")

class HubSpawn(pb.Avatar):
   from TwistedHub import TwistedTask, CopyTask
   def setHub(self,hub):
       self.hub = hub
       print "Adopting hub:",hub
   def perspective_closeoff(self,dispatcher):
       if dispatcher in self.hub.dispatchers:
          self.hub.CloseOff(dispatcher)
   def perspective_info(self):
       info = {}
       info["numrunners"] = len(self.hub.RUNNING)
       info["numrunning"] = len(self.hub.TasksOn())
       info["runners"] = [h.uuid for h in self.hub.TASKS]
       return info
   def perspective_task(self,otask):
       print "Received:",otask
       self.hub.out.write( "Received: %r\n" %(otask))
       if "reactor.stop" in otask.func:
           self.hub.finish = 1
           self.hub.tasks.append(otask)
       else:
#           print otask
           setattr(otask,"imported",True)
           self.hub.tasks.append(otask)
           self.hub.rec+=1
           dispatcher = (otask.ohost,otask.port)
           self.hub.queueback.setdefault(otask,time.time())
           if dispatcher not in self.hub.dispatchers:
              self.hub.dispatchers[dispatcher] = {}
           if dispatcher not in self.hub.dispatcher:
              queue = []
              cfs = {}
              self.hub.dispatcher[dispatcher] = [cfs,queue]
              self.hub.sentback[dispatcher] = {}
           cfs,queue = self.hub.dispatcher[dispatcher]
           n = len(cfs)
           if n == 0:
              print "Jump start SendQueue!"
              reactor.callLater(self.hub.sleeptime,self.hub.SendQueue,dispatcher,start=1)
           if n < self.hub.pdispatch:
              print "Making new connection back to",dispatcher
              factory = MyPBClientFactory()
              connector = reactor.connectTCP(otask.ohost,otask.port,factory)
              self.hub.dispatcher[dispatcher][0].setdefault((connector,factory))
              reactor.callLater(self.hub.sleeptime,self.hub.WatchDispatcher,otask,connector,factory)
       return True
   def perspective_inquire(self,tids=[]):
       if tids:
          print "Received inquiry for %d and others." %(tids[0])
       d = sets.Set(tids)
       nt = len([t for t in self.hub.tasks if t.taskid in d])
       na = len([t for t in self.hub.adding if t.taskid in d])
       no = len([t for t in self.hub.TasksOn() if t.taskid in d])
       return nt,na,no

basicNotFinished = lambda d: not (d.called and not d.paused) or \
                        not hasattr(d,"result")

notFinished = lambda d: not (d.called and not d.paused) or \
                        not hasattr(d,"result") or type(d.result) == TupleType

class MyPBClientFactory( pb.PBClientFactory):
    def clientConnectionLost(self,*args):
        print "Disconnected!",self
#        if args:
#           print args[1].getTraceback()
        self.proto.transport.loseConnection()
    def buildProtocol(self, addr):
        proto = pb.PBClientFactory.buildProtocol(self, addr)
        self.proto = proto
        return proto

class TwistedHub:
   from TwistedHub import TwistedTask, CopyTask
   def __init__(self,tasks=[],timeout=30,port=0,quiet=0,verb=0,sleeptime=0.01,clean=0,norun=0,wait=0,\
        listen=-1,stayalive=0,user=getpass.getuser(), uid=getpass.getuser(), password=None,gdir=None,\
        machines=MACHINES,modules=[],fmodules=[],namespace=globals(),sshport=0,nostop=0,nice=10,auth=0,\
        standalone=1):
       self.initialize()
       self.standalone = standalone
       if namespace:
          self.namespace=namespace
          self.namespace["self"] = self
       else: self.namespace = locals()
       self.sentback = {}
       self.goingback = {}
       self.dispatcher = {}
       self.dispatchers = {}
       self.pdispatch = 4
       self.queueback = {}
       self.gdir = gdir
       self.user = user
       self.password = None
       self.auth = auth
       self.sshport = sshport
       machines = [(":" not in machine and [machine,"1"] or machine.split(":")) for machine in machines]
       machines = [machine[0] for machine in machines for j in range(int(machine[1]))]
       md = {}
       for km in machines:
         if km not in md: md[km] = []
         md[km].append(km)
       self.machines = []
       kms = md.keys()
       while kms:
         [self.machines.append( md[km].pop(0)) for km in kms if md[km]]
         [md.pop(km) for km in kms if not md[km]]
         kms = md.keys()
       self.modules = modules
       self.fmodules = fmodules
       self.nostop = nostop
       self.tasks = tasks
       self.completed = []
       self.adding = []
       self.addingnow = []
       self.sending = []
       self.watchers = {}
       self.nsend = 0
       self.ncomplete = 0
       self.lport = port
       self.verb = verb
       self.uid = uid
       self.clean = clean
       self.norun = norun
       self.finish = 0
       self.listen = listen
       self.stayalive = stayalive
       self.stalled = 0
       COMMAND = "TwistedStation"
       self.COMMAND = " ".join([COMMAND,"-uid",self.uid])
       self.nicelevel = nice
       if self.nicelevel != None:
          self.COMMAND = " ".join([self.COMMAND,"-nice %d" % (self.nicelevel)])
       if self.gdir:
          self.COMMAND = " ".join([self.COMMAND,"-dir",self.gdir])
       if self.clean:
          self.COMMAND = " ".join([self.COMMAND,"-clean"])
       if self.norun:
          self.COMMAND = " ".join([self.COMMAND,"-norun"])
       if self.modules:
          self.COMMAND = " ".join([self.COMMAND,"-i",",".join(self.modules)])
       if self.fmodules:
          self.COMMAND = " ".join([self.COMMAND,"-f",",".join(self.fmodules)])
       self.wait = wait
       self.rec = 0
       self.sleeptime = sleeptime
       self.ntasks = len(tasks)
       self.timeout = timeout
       self.began = False
       self.done = False
       self.die = False
       pstart = time.time()
       pend = time.time()
       if (pend-pstart) > 180: raise "Time to enter password exceeded!"
       self.pid = os.getpid()
       outc = len(glob("%s/hub%d*.out" % (TWDIR,self.pid)))
       if outc: outs = "_"+str(outc)
       else: outs = ""
       self.out = open("%s/hub%d%s.out" % (TWDIR,self.pid,outs),"w")
       self.err = open("%s/hub%d%s.err" % (TWDIR,self.pid,outs),"w")
       if quiet:
          sys.stdout = self.out
          sys.stderr = self.err
       self.tstart = time.time()
#       self.clientFactory = SimpleClientFactory(hub=self,user=self.user,password=self.password,lport=self.lport,verb=0,clean=self.clean)
#       self.clientFactory.protocol = SimpleTransport
       self.log = cStringIO.StringIO()
       if 1 or self.verb:
#          from twisted.python import util, threadable, usage, log
          logging.startLogging(self.verb and sys.stdout or self.log,setStdout=0)
       self.reactor = reactor
       self.psize = 10
       tfac = 5
       if self.stayalive and self.standalone: tfac = tfac*4
       if hasattr(reactor.threadpool,"max"):
          self.psize = max([8+tfac*len(self.machines),reactor.threadpool.max])
       else:
          self.psize = 8+tfac*len(self.machines)
       if 1 or standalone:
          self.sshport = AddManhole(self.user,"",self.namespace,self.sshport,now=verb)
#       else:
#          self.sshport = AddManhole("guest","guest",self.namespace,self.sshport,now=verb)
       self.out.write("ssh port = %d\n" % (self.sshport.getHost().port))
       self.out.flush()
#       self.out.write("simple port = %d\n" % (self.simpleport.getHost().port))
#       self.out.flush()
       self.passback = []
       self.addhosts = [m for m in self.machines]
       reactor.callLater(0.1,self.AddNextHost)
#       self.watchdeaths = task.LoopingCall(self.WatchDeaths)
#       self.watchdeaths.start(1)
       self.hostadd = task.LoopingCall(self.AreWeReady)
       self.hostadd.start(0.25)
       if self.listen >= 0:
          reactor.callLater(0.01,self.Listening)
       if self.standalone:
          reactor.run()
          if quiet:
             sys.stdout = sys.__stdout__
             sys.stderr = sys.__stderr__
          self.out.close()
          self.err.close()
          if not quiet:
             os.remove(self.out.name)
             os.remove(self.err.name)
             for s in self.ALLHOSTS:
                 s.stdout.close()
                 if os.path.exists(s.stdoutn):
                    os.remove(s.stdoutn)
                 s.stderr.close()
                 if os.path.exists(s.stderrn):
                    os.remove(s.stderrn)
       elif reactor.running and self.clean:
           print "getting deferred"
           d = defer.Deferred()
           d.addCallback(lambda result: self.FinishClean())
           return d.callback(True)
   def FinishClean(self,*args):
       print "inside deferred"
       print self.clean
       while self.clean != -1:
          print "Waiting for clean to finish."
          time.sleep(1)
       return self.clean
   def Status(self):
       r = len(self.TasksOn()),len(self.TASKS),len(self.adding),len(self.addingnow),len(self.tasks), \
               [(h.rhost,t.func) for h,t in zip(self.HostsOn(),self.TasksOn())]
       return r
   def Problem(self,result):
       print result
       logging.err(result)
       return False
   def WatchDeaths(self):
       if not self.addhosts: return
       self.AddNextHost()
   def GetPass(self,password):
       if password: self.password = password
       elif "pw" in os.environ: self.password = os.environ["pw"]
       elif "pwfile" in os.environ and os.path.exists(os.environ["pwfile"]): self.password = open(os.environ["pwfile"],"r").read().strip()
       else: self.password=getpass.getpass("%s's password: " % (self.user))
   def initialize(self):
#       self.GetPass(password)
       self.TASKS = {}
       self.USE = {}
       self.RESULTS = {}
       self.RUNNING = []
       self.ALLHOSTS = []
       self.STARTED = []
       self.CONNECTORS = {}
       self.CONNECTORS2 = {}
       self.LC = {}
       self.SSH = {}
       self.KILL = {}
       self.currentloads = {}
       self.conns = []
       self.paused = False
       self.added = 0
       self.added2 = 0
       self.htasks = {}
   def AddNextHost(self):
       if len(self.addhosts):
          self.AddHost()
#          self.AddHost(self.addhosts[0])
          if self.clean: self.AddNextHost()
#          reactor.callInThread(self.AddNextHost)
#       elif hasattr(self,"hostadd") and self.hostadd.running:
#          reactor.callFromThread(self.hostadd.stop)
   def AddHost(self,host=None,number=0):
#       if host in self.SSH:
#          ssh1 = self.SSH[host][0]
#          print ssh1
#          print dir(ssh1)
#          factory = ssh1.factory
#          print factory
#          print dir(factory)
#          p = factory.p
#          print p
#          print dir(p)
#          sc = p.sc
#          sc.serviceStarted(1)
#          reactor.callFromThread(reactor.wakeUp)
#       else:
       if not host: host = self.addhosts[0]
       if host not in self.SSH:
          self.SSH[host] = []
       if number == 0:
          number = min([self.addhosts.count(host),8])
          [self.addhosts.remove(host) for j in range(number)]
       print "AddHost",host,number
       clientFactory = SimpleClientFactory(hub=self,user=self.user,password=self.password,host=host,number=number,lport=self.lport,verb=self.verb,clean=self.clean)
       clientFactory.protocol = SimpleTransport
       ssh1 = reactor.connectTCP(host,22,clientFactory,timeout=self.timeout)
       clientFactory.ssh = ssh1
       self.SSH[host].append(ssh1)
       reactor.callLater(0.01,self.sshConnected,host,ssh1)
       reactor.callFromThread(reactor.wakeUp)
       print self.addhosts
#       if not self.clean: self.AddNextHost()
   def fixConnections(self,nc=1):
       print "Fix connections?"
       for host in self.SSH:
           bad = []
           [bad.append(j) for j,ssh in enumerate(self.SSH[host]) \
                if ssh.state == "disconnected" \
                        or not hasattr(ssh.factory.p.sc,"chs") \
                        or len(ssh.factory.p.sc.chs) < ssh.factory.p.sc.number]
           if bad:
              for rp in range(4):
                 print "Fixing %d connections for %s!" % (len(bad),host)
                 print >>self.out, "Fixing %d connections for %s!" % (len(bad),host)
                 print >>self.err, "Fixing %d connections for %s!" % (len(bad),host)
              [self.SSH[host][j].disconnect() for j in bad if self.SSH[host][j].state != "connected"]
              [self.SSH[host].pop(j) for j in bad]
#              self.added -= 1
              [reactor.callLater(0.5,self.AddHost,host,nc) for j in bad]
   def sshConnected(self,host,ssh1):
       if ssh1.state != "connected":
          reactor.callLater(0.25,self.sshConnected,host,ssh1)
          return
#       if not self.clean:
#          reactor.callLater(0.1,self.AddNextHost)
       text = "Added %s (%s)\n" % (host,ssh1.state)
       sys.stdout.write( text)
       if not self.clean:
          reactor.callLater(0.1,self.WaitNextHost)
#       self.increment(1)
   def increment(self,x,value=1):
       if 1 or not self.added:
          reactor.suggestThreadPoolSize(max([20,self.psize]))
          reactor.threadpool.adjustPoolsize(max([reactor.threadpool.workers,min([reactor.threadpool.max,20])]))
#          print reactor.threadpool.min,
#          print reactor.threadpool.max,
#          print reactor.threadpool.workers,self.psize
#          reactor.threadpool.adjustPoolsize(self.psize)
       if x == 2: self.added2 += value
       elif x == 1: self.added += value
       print "inc",self.added,self.added2,len(self.CONNECTORS)
   def Watching(self):
       print "Start Watching Connections!"
       if self.wait:
          self.wa = task.LoopingCall(self.WatchAdded)
          self.wa.start(self.sleeptime)
       else:
          self.wr = task.LoopingCall(self.WatchRunning)
          self.wr.start(self.sleeptime)
   def WatchAdded(self):
       if 0 and self.norun:
          if len(self.STARTED) < len(self.machines):
            return
       else:
          nr = len(self.CONNECTORS)
          if not self.clean and len(self.CONNECTORS) < len(self.machines):
#          if len(self.CONNECTORS) < len(self.machines):
#             if nr != len(self.CONNECTORS):
                hosts = [h.rhost for h in self.CONNECTORS]
                hosts.sort()
                text = "(%d/%d) %r\n" %  (len(self.CONNECTORS),len(self.machines),hosts)
                sys.stdout.write( text)
                if not self.clean and not self.addhosts:
                   time.sleep(1)
                   self.stalled += 1
                   print "Stalled!",self.stalled
                   if self.stalled >=5:
                      self.fixConnections()
#                nr = len(self.CONNECTORS)
#             return
          elif len(self.RUNNING) == len(self.machines):
             text =  "\nAll %d cylinders firing away!\n" % (len(self.CONNECTORS.keys()))
             sys.stdout.write( text)
             self.began = True
             if not self.clean:
                self.wr = task.LoopingCall(self.WatchRunning)
                self.wr.start(self.sleeptime)
             self.wa.stop()
             if self.clean:
                self.clean = -1
                self.Continue()
   def AddConnectors(self):
       if len(self.conns) == len(self.machines):
          reactor.callLater(0.1,self.Watching)
          reactor.callLater(0.1,self.hostconn.stop)
   def MakeConnector(self,host):
       if not (self.finish or self.die):
          rhost = host.rhost
          rport = host.rport
          sport = host.sport
          lport = host.lport
          lport2 = host.lport2
          user = host.conn.user2
          password = host.conn.password2
          text = "Creating connector to local ports %d %d.\n" % (lport,lport2)
          sys.stdout.write( text)
          text = "Creating connector to %s:%d (%s,%d) using local ports %d %d.\n" % (rhost,rport,user,sport,lport,lport2)
          self.out.write( text)
          self.out.flush()
          text = "ssh %s@%s -p %d\n" % (user,rhost,sport)
          self.out.write( text)
          self.out.flush()
          factory = MyPBClientFactory()
          connector = reactor.connectTCP('localhost',lport,factory)
          reactor.callLater(0.1,self.WatchConnector,connector,host,user,password,factory)
   def WatchConnector(self,connector,host,user,password,factory):
       print "connector", connector,connector.state
       if connector.state == "connecting":
          reactor.callLater(0.2,self.WatchConnector,connector,host,user,password,factory)
          return
       if connector.state == "disconnected":
#          print "Reconnect with new factory with new factory!"
#          lport = host.lport
#          user = host.conn.user2
#          password = host.conn.password2
#          factory = MyPBClientFactory()
#          connector = reactor.connectTCP('localhost',lport,factory)
          connector.connect()
          reactor.callLater(0.5,self.WatchConnector,connector,host,user,password,factory)
          return
       d = factory.login(UsernamePassword(user,password))
       reactor.callLater(0.1,self.WatchFactory,d,host,connector,factory)
   def WatchFactory(self,d,host,connector,factory):
       print "watch factory",d
       print "watch factory",connector,connector.state
       if connector.state == "disconnected":
          connector.connect()
          lport2 = host.lport2
          user = host.conn.user2
          password = host.conn.password2
          reactor.callLater(0.2,self.WatchConnector,connector,host,user,password,factory)
          return
       if not hasattr(d,"result") or not hasattr(d.result,"callRemote"):
          reactor.callLater(0.5,self.WatchFactory,d,host,connector,factory)
          return
       d.addCallback(lambda remote: self.FireItUp(host,connector,remote))
       d.addErrback(self.WhatHappened)
       reactor.callFromThread(reactor.wakeUp)
   def WhatHappened(self,reason):
       print reason
       return False
   def FireItUp(self,host,connector,remote):
       print "Fire it up!",host
       print "fired up?", self.added, self.added2, len(self.CONNECTORS)
       self.TASKS.setdefault(host,[])
       self.RESULTS.setdefault(host,[])
       self.CONNECTORS.setdefault(host,[connector,remote])
       self.RUNNING.append(host)
       self.increment(1)
       lport2 = host.lport2
       user2 = host.conn.user2
       password2 = host.conn.password2
       factory2 = MyPBClientFactory()
       connector2 = reactor.connectTCP('localhost',lport2,factory2)
       reactor.callLater(0.1,self.WatchConnector2,connector2,host,user2,password2,factory2)
   def WatchConnector2(self,connector2,host,user2,password2,factory2):
       print "connector2", connector2,connector2.state
       if connector2.state == "connecting":
          reactor.callLater(0.5,self.WatchConnector2,connector2,host,user2,password2,factory2)
          return
       if connector2.state == "disconnected":
          connector2.connect()
          reactor.callLater(0.5,self.WatchConnector2,connector2,host,user2,password2,factory2)
          return
       d2 = factory2.login(UsernamePassword(user2,password2))
       reactor.callLater(0.1,self.WatchFactory2,d2,host,connector2,factory2)
   def WatchFactory2(self,d2,host,connector2,factory2):
       print "watch factory2",d2
       print "watch factory2",connector2,connector2.state
       if connector2.state == "disconnected":
          connector2.connect()
          lport2 = host.lport2
          user2 = host.conn.user2
          password2 = host.conn.password2
          reactor.callLater(0.5,self.WatchConnector2,connector2,host,user2,password2,factory2)
          return
       if not hasattr(d2,"result") or not hasattr(d2.result,"callRemote"):
          reactor.callLater(0.5,self.WatchFactory2,d2,host,connector2,factory2)
          return
       d2.addCallback(lambda remote: self.FireItUp2(host,connector2,remote))
       d2.addErrback(self.WhatHappened)
   def FireItUp2(self,host,connector2,remote2):
       self.CONNECTORS2.setdefault(host,[connector2,remote2])
       print "fired up2?",
       print self.added,self.added2,len(self.CONNECTORS)
       host.use = 1
       self.increment(2)
   def WaitNextHost(self):
       n = sum([ssh.factory.number for host in self.SSH for ssh in self.SSH[host]])
       print n
       m = 0
#       for host in self.SSH:
#           for ssh in self.SSH[host]:
#               if hasattr(ssh,"factory") and hasattr(ssh.factory,"p") and \
#                  hasattr(ssh.factory.p,"sc") and hasattr(ssh.factory.p.sc,"chs"):
#                  m += len(getattr(ssh.factory.p.sc,"chs",[]))
       m = len(self.CONNECTORS2)
       if 0 and m != n:
          print "WaitNextHost!",n,m
          reactor.callLater(0.5,self.WaitNextHost)
          return
       reactor.callLater(0.1,self.AddNextHost)
   def AreWeReady(self):
       if self.clean or (not len(self.addhosts) and len(self.CONNECTORS) == len(self.CONNECTORS2) == len(self.machines)):
          reactor.callLater(0.1,self.Watching)
          if hasattr(self,"hostadd") and self.hostadd.running:
             reactor.callFromThread(self.hostadd.stop)
   def RunTasks(self,tasks):
       self.tasks.extend(tasks)
       def doterator():
           running = []
           for item in tasks:
#               print item
               if not (hasattr(item,"done") and item.done and hasattr(item,"result")):
                  running.append(item)
               yield None
       c = task.cooperate(doterator())
       return c,done
   def GetAdding(self):
#       print "GetAdding",len(self.tasks)
       stasks = [self.tasks.pop(0) for j in range(len(self.tasks))]
       for otask in stasks:
           if (len(self.adding)+len(self.addingnow))>(2*len(self.TASKS)):
              [self.tasks.insert(0,t) for t in stasks if t not in self.adding and t not in self.addingnow]
              break
           if (not hasattr(otask,"condition") or otask.getCondition()):
              if getattr(otask,"now",False): self.addingnow.append(otask)
              else: self.adding.append(otask)
   def WatchSpawn(self):
       gs = False
       if not self.paused and (self.tasks or self.adding or self.addingnow):
#          adding = [otask for otask in [self.adding.pop(0) for j in range(len(self.adding))] if not hasattr(otask,"condition") or otask.getCondition()]
#          addingnow = [otask for otask in self.tasks if not hasattr(otask,"condition") or otask.getCondition() and (hasattr(otask,"host") or hasattr(otask,"station") or getattr(otask,"now",False))]
#          adding = [otask for otask in self.tasks if not hasattr(otask,"condition") or otask.getCondition() and not (hasattr(otask,"host") or hasattr(otask,"station") or getattr(otask,"now",False))]
#          addingnow = []
#          adding = []
#          [[adding,addingnow][getattr(otask,"now",False)].append(otask) for otask in self.tasks if ((len(adding)+len(addingnow))<2*len(self.TASKS)) and (not hasattr(otask,"condition") or otask.getCondition())]
#          stasks = [self.tasks.pop(0) for j in range(len(self.tasks))]
#          for otask in stasks:
#              if (len(self.adding)+len(self.addingnow))>(2*len(self.TASKS)): break
#              if (not hasattr(otask,"condition") or otask.getCondition()):
#                 if getattr(otask,"now",False): self.addingnow.append(otask)
#                 else: self.adding.append(otask)
#          [self.tasks.remove(otask) for otask in addingnow if otask in self.tasks]
#          [self.tasks.remove(otask) for otask in adding if otask in self.tasks]
#          adding = [otask for otask in self.tasks if not hasattr(otask,"condition") or otask.getCondition()]
#          adding = [otask for otask in self.tasks if not hasattr(otask,"condition") or otask.getCondition() and not getattr(otask,"now",False)]
#          [self.tasks.remove(otask) for otask in addingnow if otask in self.tasks]
#          [self.tasks.remove(otask) for otask in adding if otask in self.tasks]
#          adding1 = [otask for otask in adding if hasattr(otask,"host") or hasattr(otask,"station") or getattr(otask,"now",False)]
#          adding2 = [otask for otask in adding if not hasattr(otask,"host") and not hasattr(otask,"station")]
#          self.adding = adding1 + adding2
#          self.addingnow.extend(addingnow)
#          self.adding.extend(adding)
          self.GetAdding()
#          print len(self.adding),len(self.addingnow)
          hnames = [h.rhost for h in self.TASKS]
          [self.htasks.setdefault(h,0) for h in hnames]
          running = self.TASKS.keys()
          runningu = {}
          for h in running:
              r = h.rhost
              if r not in runningu: runningu[r] = []
              runningu[r].append(h)
          runningo = []
          while [v for v in runningu.values() if len(v)]:
              for r in runningu:
                 if runningu[r]:
                    runningo.append(runningu[r].pop(0))
          gs = True
#          runningo = [host for host in runningo if host.use and self.TASKS[host] == []]
          self.runningn = [host for host in runningo if host.use]
          self.runningo = [host for host in runningo if host.use and self.TASKS[host] == []]
#          print len(self.runningo),len(self.adding),len(self.addingnow)
          d = defer.Deferred()
          if self.addingnow and self.runningn:
              d.addCallback(lambda result: self.GoSpawn(self.runningn,self.addingnow))
          if self.adding and self.runningo:
              d.addCallback(lambda result: self.GoSpawn(self.runningo,self.adding))
          d.addCallback(lambda result: reactor.callLater(self.sleeptime,self.WatchSpawn))
          d.callback(True)
#          reactor.callLater(self.sleeptime,self.WatchSpawn)
#          reactor.callLater(self.sleeptime,self.GoSpawn)
       else:
          reactor.callLater(self.sleeptime,self.WatchSpawn)
   def GoSpawn(self,running,adding):
       if not adding: return
#       print "GoSpawn",len(running),len(adding)
#       print [t.taskid for t in adding if not hasattr(t,"assigned")]
       for host in running:
           if not adding: break
           atasks = self.GoSpawn1(host,adding)
           [adding.remove(t) for t in atasks]
   def GoSpawn1(self,host,adding):
       if not adding: return
       sname = host.rhost.split(".")[0]
       atasks = []
       for otask in adding:
           if not hasattr(otask,"assigned") and \
               (getattr(otask,"local",False) and host.rhostip == ipaddr) or \
               (not getattr(otask,"local",False) and (getattr(otask,"host",None) == sname or \
                (not getattr(otask,"host",None) and getattr(otask,"station",None) == host.uuid or not hasattr(otask,"station")))):
               if (not getattr(otask,"now",False) and self.TASKS[host] == []) or getattr(otask,"now",False):
                  otask.assigned = True
                  if 1 or self.verb:
                     print "ASSIGNING %r to %r (%s,%r)" % (otask.taskid,host.uuid,sname,otask.local)
                  atask = otask
                  atask.ahost = host
                  atasks.append(atask)
                  if getattr(atask,"now",False):
                     print "IT HAS NOW!"
                     reactor.callLater(self.sleeptime,self.NowForHost,host,otask)
                  else:
                     self.TASKS[host].append(atask)
                     reactor.callLater(self.sleeptime,self.SpawnToHost,host,otask=atask)
                  self.htasks[host.rhost] += 1
                  break
       return atasks
#       if atasks:
#          [adding.remove(atask) for atask in atasks]
#          reactor.callFromThread(reactor.wakeUp)
##          if not adding: break
   def WatchRunning(self):
       self.tnow = time.time()
       if not hasattr(self,"ws"):
          text = "Starting up!\n"
          sys.stdout.write( text)
          print "Running (%d)!" % (self.sshport.getHost().port)
       reactor.callFromThread(reactor.wakeUp)
       if self.norun:
          if len(self.STARTED) < len(self.machines):
             reactor.callLater(self.sleeptime,self.Continue)
             return
       else:
          if not len(self.CONNECTORS.keys()):
            return
          if not hasattr(self,"ws"):
             reactor.callLater(self.sleeptime,self.WatchSpawn)
             self.ws = True
#          if not hasattr(self,"ws"):
#             self.ws = task.LoopingCall(self.WatchSpawn)
#             self.ws.start(self.sleeptime)
#             self.gs = task.LoopingCall(self.GoSpawn)
#             self.gs.start(self.sleeptime)
          l = 0
          self.nr0 = 0
          if not self.finish and not self.die:
             l = l + 1
             time.sleep(self.sleeptime)
             nr = len(self.completed)
             if not self.stayalive and nr == self.ntasks: self.finish = 1
             if self.verb>1 and ((self.verb and not (l%40)) or (nr != self.nr0)):
                sys.stdout.write("%d %d %d\n" % (nr,self.ntasks,self.finish))
                sys.stdout.flush()
             self.nr0 = nr
             return
          reactor.callLater(self.sleeptime,self.Continue)
   def Continue(self):
       if not self.norun:
          if self.wr.running: self.wr.stop()
          reactor.callFromThread(self.Gather)
          if self.die:
             text =  "\nDying prematurely with %d tasks!\n" % (len(self.tasks)+len(self.adding)+len(self.addingnow))
          else:
             text =  "\nAll done!\n"
#          self.ws.stop()
#          self.gs.stop()
#          self.watchdeaths.stop()
          sys.stdout.write( text)
          sys.stdout.flush()
          reactor.callFromThread(reactor.wakeUp)
#          while len(self.CONNECTORS.keys()) < len(self.machines):
          while (self.added < len(self.machines)) and not self.die:
             text =  "Waiting for remaining %d stations to start up so we can kill them, too...\n" % \
                (len(self.machines)-len(self.CONNECTORS.keys()))
             sys.stdout.write( text)
             sys.stdout.flush()
             reactor.callFromThread(reactor.wakeUp)
             time.sleep(self.sleeptime)
          reactor.callLater(self.sleeptime,self.End)
          text =  "Waiting for things to shut down...\n"
          sys.stdout.write( text)
          sys.stdout.flush()
#          while self.RUNNING: time.sleep(sleeptime)
       if self.standalone:
           text = "Can we call reactor.stop yet?\n"
           sys.stdout.write( text)
           text = "Now we can!\n"
           sys.stdout.write( text)
       self.done = True
       self.tend = time.time()
       text = "Time to execute=%f\n" % (self.tend-self.tstart)
       sys.stdout.write( text)
#       if not self.nostop: self.Stop()
   def Gather(self):
       results = [result for host in self.RESULTS for result in self.RESULTS[host] if hasattr(result,"done")]
       order = argsort([result.result[2] for result in results])
       results = [results[j] for j in order]
       self.timings = [result.result[0] for result in results]
       self.loads = [result.result[1] for result in results]
       self.indices = [result.result[2] for result in results]
       self.results = [result.result[3] for result in results]
   def Elapsed(self):
       return time.time()-self.tstart
   def rhosts(self):
       hosts = [h.rhost for h in self.RUNNING]
       hosts.sort()
       return hosts
   def Stop(self):
       if not self.norun:
          for host in self.RESULTS:
             [host.loseConnection() for host in self.RESULTS]
             [host.conn.serviceStopped() for host in self.RESULTS]
             [self.CONNECTORS[connector][0].stopConnecting() for connector in self.CONNECTORS if self.CONNECTORS[connector][0].state == "connecting"]
             [self.CONNECTORS2[connector][0].stopConnecting() for connector in self.CONNECTORS2 if self.CONNECTORS2[connector][0].state == "connecting"]
       print "Stop Listening to",self.sshport
       self.sshport.stopListening()
       if hasattr(self,"listen") and hasattr(self.listen,"getHost"):
          print "Stop Listening to",self.listen
          self.listen.stopListening()
       if self.standalone:
#          reactor.callFromThread(reactor.disconnectAll)
          print "Stopping reactor!"
          reactor.callFromThread(reactor.stop)
   def End(self):
       sys.stdout.flush()
       self.die = 1
       for host in self.RUNNING:
           if host in self.TASKS:
              if self.TASKS[host] == []:
                 print "Soft landing for ", host.rhost
                 reactor.callLater(self.sleeptime,self.TerminateHost,host)
              else:
                 print "Hard landing for ", host.rhost
                 reactor.callLater(self.sleeptime,self.KillHostChild,host,9)
       reactor.callLater(0.1,self.WatchEnd)
   def WatchEnd(self):
       if self.RUNNING:
          reactor.callLater(0.1,self.WatchEnd)
          print "Wait!"
          return
       for host in self.SSH:
           for s in self.SSH[host]:
               print s,s.state
               if s.state == "connected": s.disconnect()
#               print "disconnecting?"
#                  self.TASKS[host].append(TwistedTask(-1,"reactor.stop"))
#                  reactor.callInThread(self.SpawnToHost,host)
       reactor.callLater(0.1,self.Stop)
   def TerminateHosts(self):
      [self.TerminateHost(host) for host in self.CONNECTORS2.keys()]
   def TerminateHost(self,host):
      connector,remote = self.CONNECTORS2[host]
      if connector.state == "disconnected":
         if self.verb: print "Need to reconnect?!?!??"
         connector.connect()
      if connector.state != "connected":
         if self.verb: print "Waiting for connection!"
         reactor.callLater(0.1,self.TerminateHost,host)
         return
      d = remote.callRemote("stop")
      return d
   def PrintElapsed(self):
      if hasattr(self.elapsed):
         for host in self.HostsOn():
             print host.rhost,getattr(self.elapsed[host],"result",None)
   def GetElapsed(self):
      self.elapsed = {}
      [self.GetElapsedForHost(host) for host in self.CONNECTORS2]
   def GetElapsedForHost(self,host):
      connector,remote = self.CONNECTORS2[host]
      if connector.state == "disconnected":
         if self.verb: print "Need to reconnect?!?!??"
         connector.connect()
      if connector.state != "connected":
         if self.verb: print "Waiting for connection!"
         reactor.callLater(0.1,self.GetElapsedForHost,host)
      tstart = time.time()
      d = remote.callRemote("elapsed")
      self.elapsed[host] = d
      if self.verb: print "Elapsed for",host,self.elapsed[host]
   def GetLoads(self):
      self.currentloads = {}
      [self.GetLoadForHost(host) for host in self.CONNECTORS2]
   def GetLoadForHost(self,host):
      connector,remote = self.CONNECTORS2[host]
      if connector.state == "disconnected":
         if self.verb: print "Need to reconnect?!?!??"
         connector.connect()
      if connector.state != "connected":
         if self.verb: print "Waiting for connection!"
         reactor.callLater(0.1,self.GetLoadForHost,host)
      tstart = time.time()
      d = remote.callRemote("load")
      self.currentloads[host] = d
      if self.verb: print "Load for",host,self.currentloads[host]
   def KillHostChildren(self,sig=None):
      [self.KillHostChild(host,sig=sig) for host in self.CONNECTORS2]
   def KillHostChild(self,host,sig=None):
      connector,remote = self.CONNECTORS2[host]
      if connector.state == "disconnected":
         if self.verb: print "Need to reconnect?!?!??"
         connector.connect()
      if connector.state != "connected":
         if self.verb: print "Waiting for connection!"
         reactor.callLater(0.1,self.KillHostChild,host,sig=sig)
      tstart = time.time()
      d = remote.callRemote("kill",sig)
   def NowForHost(self,host,otask):
      print "NOWFORHOST",host,otask
      connector,remote = self.CONNECTORS2[host]
      if connector.state == "disconnected":
         if self.verb: print "Need to reconnect?!?!??"
         connector.connect()
      if connector.state != "connected":
         if self.verb: print "Waiting for connection!"
         reactor.callLater(0.1,self.NowForHost,host)
      print "Sending %d to urgent path!" % (otask.taskid)
      ctask = CopyTask()
      [setattr(ctask,attr,getattr(otask,attr)) for attr in otask.elements if hasattr(otask,attr)]
      cwd = otask.path
      scwd = cwd.split("/")
      op,lhost = os.uname()[:2]
      ctask.setPath(cwd)
      tstart = time.time()
      d = remote.callRemote("task",ctask)
      d.addCallback(lambda result: self.NowForHostDone(host,otask,time.time()-tstart,result))
      d.addErrback(lambda reason: (reason.value))
   def NowForHostDone(self,host,otask,telapse,result):
      results = [telapse] + list(result)
      if results[4]: results[3] = cPickle.loads(results[3])
      otask.setResult(results)
      if not otask.imported: otask.longResult()
      if not otask.imported: self.completed.append(otask)
      print "Got %d back from urgent path!" % (otask.taskid)
      if self.verb:
         sys.stdout.write("%s\n" % (str(results[3])))
         sys.stdout.write("Time to execute for %r was %f.\n" % (otask.taskid,results[0]))
      if otask.imported:
          if self.verb: print "Sending back",otask.taskid
          self.QueueBack(otask)
          reactor.callFromThread(reactor.wakeUp)
   def CleanTasks(self):
       [self.TASKS[k].pop(0) for k in self.TASKS if self.TASKS[k]]
   def SpawnToHost(self,host,otask=None):
       if host in self.TASKS:
           if host not in self.RUNNING:
               self.TASKS.pop(host)
               return 
#               break
           if self.TASKS[host] or otask:
                if host not in self.CONNECTORS:
                   if verb:
                      print "Waiting for connector?"
                      sys.stdout.flush()
                   reactor.callLater(0.1,self.SpawnToHost,host)
                connector,remote = self.CONNECTORS[host]
                if connector.state == "disconnected":
                   if self.verb: print "Need to reconnect?!?!??"
                   connector.connect()
                if connector.state != "connected":
                   if self.verb: print "Waiting for connection!"
                   reactor.callLater(0.1,self.SpawnToHost,host,otask=otask)
                if otask and not self.TASKS[host]:
                   self.TASKS[host].append(otask)
                otask = self.TASKS[host][0]
                ctask = CopyTask()
                [setattr(ctask,attr,getattr(otask,attr)) for attr in otask.elements if hasattr(otask,attr)]
                cwd = otask.path
                scwd = cwd.split("/")
                op,lhost = os.uname()[:2]
                ctask.setPath(cwd)
                if self.verb:
                   text = "sending %r to %s(%d<-%d)\n" % (ctask.taskid,host.rhost,host.rport,host.lport)
                   sys.stdout.write( text)
                tstart = time.time()
                d = remote.callRemote("task",ctask)
                host.lasttask = otask
                host.last = d
                host.last.done = False
                if self.verb: print "Waiting for result",otask.taskid
                if "reactor.stop" not in ctask.func:
                   d.addCallback(lambda result: self.WaitForHost(host,time.time()-tstart))
                   d.addErrback(lambda reason: (reason.value))
#                   if host not in self.watchers:
#                      self.watchers[host] = task.LoopingCall(self.WaitForHost,host)
#                   self.watchers[host].start(self.sleeptime)
                reactor.callFromThread(reactor.wakeUp)
                if "reactor.stop" in otask.func:
                    self.TASKS[host].remove(otask)
                    self.TASKS.pop(host)
#                else:
#                    self.watchers[host] = task.LoopingCall(self.WaitForHost,host)
#                    self.watchers[host].start(self.sleeptime)
   def HostsOn(self):
       return [h for h,v in self.TASKS.items() if v]
   def FlushHosts(self):
       return [reactor.callLater(self.sleeptime,self.WaitForHost,h) for h in self.HostsOn() if hasattr(h.last,"result")]
   def TasksOn(self):
       return [v[0] for h,v in self.TASKS.items() if v]
   def WaitForHost(self,host,telapse):
#       if not self.TASKS[host]:
#          self.watchers[host].stop()
#          return
       otask = self.TASKS[host][0]
       d = host.last
#       if not (d.called and not d.paused) or not hasattr(d,"result") or type(d.result) == TupleType:
#           return
       self.ncomplete = self.ncomplete + 1
       if not otask.imported:
          if host in self.RESULTS: self.RESULTS[host].append(d)
          else: self.RESULTS.setdefault(host,[d])
       if self.verb: print "Got result for",otask.taskid
       if hasattr(d,"result"):
          results = [telapse] + list(d.result)
          if results[4]: results[3] = cPickle.loads(results[3])
#          host.timing = results[0]
#          host.load = results[1][0]
          otask.setResult(results)
          if not otask.imported: otask.longResult()
          print otask
          if self.verb: print results
          if not otask.imported: self.completed.append(otask)
          if self.verb:
             sys.stdout.write("%s\n" % (str(d.result)))
             sys.stdout.write("Time to execute for %r was %f.\n" % (otask.taskid,results[0]))
          sys.stdout.flush()
          self.TASKS[host].pop(0)
          if otask.imported:
              if self.verb: print "Sending back",otask.taskid
#              self.queueback.setdefault(otask)
              self.QueueBack(otask)
#              reactor.callInThread(self.QueueBack,otask)
              reactor.callFromThread(reactor.wakeUp)
       elif self.RUNNING:
          sys.stdout.write("Reinserting the task into the queue!\n")
          sys.stdout.flush()
          delattr(otask,"assigned")
          delattr(host,"lasttask")
          self.tasks.insert(0,otask)
          self.TASKS[host].pop(0)
       else:
          sys.stdout.write("Ran out of connected stations!\n")
          sys.stdout.flush()
          reactor.callLater(0.1,self.End)
#          reactor.callFromThread(self.Stop)
#       if otask.imported:
#          while not hasattr(otask,"sent"):
#            if self.verb: print "Waiting for send back!"
#            time.sleep(self.sleeptime)
#       if host in self.watchers: self.watchers[host].stop()
       host.last.done = True
   def Listening(self):
       self.realm = HubRealm()
       self.realm.setHub(self)
       self.portal = Portal(self.realm)
       if self.auth:
          print "Access set to",self.user
          checker = InMemoryUsernamePasswordDatabaseDontUse()
          checker.addUser(self.user,self.password)
       else:
          print "Access set to anonymous"
          checker = InMemoryUsernamePasswordDatabaseDontUse()
          checker.addUser("anonymous","anonymous")
       self.portal.registerChecker(checker)
       self.listen = reactor.listenTCP(self.listen, pb.PBServerFactory( self.portal))
       port = self.listen.getHost().port
       sys.stdout.write("HUB PORT=%d\n" % (port))
       sys.stdout.flush()
       self.out.write("HUB PORT=%d\n" % (port))
       self.out.flush()
   def QueueBack(self,otask):
       dispatcher = (otask.ohost,otask.port)
       cfs,queue = self.dispatcher[dispatcher]
       if otask not in queue:
          queue.append(otask)
   def OldQueueBack(self,otask):
       self.queueback.setdefault(otask,time.time())
       dispatcher = (otask.ohost,otask.port)
       if dispatcher not in self.dispatchers:
          self.dispatchers[dispatcher] = {}
       if dispatcher not in self.dispatcher:
          queue = []
          cfs = {}
          self.dispatcher[dispatcher] = [cfs,queue]
          self.sentback[dispatcher] = {}
          print "Jump start SendQueue!"
          reactor.callLater(self.sleeptime,self.SendQueue,dispatcher)
#       cfs,queue = self.dispatcher[(otask.ohost,otask.port)]
       cfs,queue = self.dispatcher[dispatcher]
       if otask not in queue:
          queue.append(otask)
       n = len(cfs)
       if n < self.pdispatch:
          print "Making new connection back to",dispatcher
          factory = MyPBClientFactory()
          connector = reactor.connectTCP(otask.ohost,otask.port,factory)
          self.dispatcher[dispatcher][0].setdefault((connector,factory))
          reactor.callLater(self.sleeptime,self.WatchDispatcher,otask,connector,factory)
   def WatchDispatcher(self,otask,connector,factory):
       dispatcher = (otask.ohost,otask.port)
       cfs,queue = self.dispatcher[dispatcher]
       if connector.state != "connected":
          print "dispatcher", dispatcher
          print (time.time() - self.queueback[otask])
          if connector.state == "connecting" and (time.time() - self.queueback[otask]) < 60:
             print connector.state,"go BACK and WAIT!"
             reactor.callLater(1+self.sleeptime,self.WatchDispatcher,otask,connector,factory)
          else:
             if connector.state == "disconnected":
                print "Stop connecting to dispatcher!",connector
                connector.stopConnecting()
                self.dispatcher[dispatcher][0].pop((connector,factory))
             if otask.done: reactor.callLater(self.sleeptime,self.QueueBack,otask)
          return
       print "dispatcher", connector,connector.state
       if self.auth:
          d = factory.login(UsernamePassword(self.user,self.password))
       else:
          d = factory.login(UsernamePassword("anonymous","anonymous"))
#       reactor.callLater(self.sleeptime,self.AddDispatcher,otask,connector,d)
       d.addCallback(lambda result: self.AddDispatcher(otask,connector,result))
       reactor.callFromThread(reactor.wakeUp)
#       return d
   def AddDispatcher(self,otask,connector,result):
#       print connector,d
#       if not hasattr(d,"result"):
#          reactor.callLater(self.sleeptime,self.AddDispatcher,otask,connector,d)
#          return
#       result = d.result
       dispatcher = (otask.ohost,otask.port)
       print "Got new dispatcher",otask.taskid,result
       self.dispatchers[dispatcher][connector] = result
#       self.SendQueue(dispatcher)
#       self.SendBackOne(otask)
   @defer.inlineCallbacks
   def SendBackThese(self,dispatcher,otasks):
       otasks = [otask for otask in otasks if otask not in self.goingback]
       otasks = [otask for otask in otasks if otask not in self.sentback[dispatcher]]
       [self.goingback.setdefault(otask) for otask in otasks]
       for n,otask in enumerate(otasks):
           self.SendBackOne(otask,n)
           yield
#       reactor.callLater(self.sleeptime,self.CheckBackThese,dispatcher,otasks)
   def CheckBackThese(self,dispatcher,otasks):
       o = [otask for otask in otasks if otask not in self.sentback[dispatcher]]
       if len(o):
          reactor.callLater(self.sleeptime,self.CheckBackThese,dispatcher,otasks)
          return
#       reactor.callLater(self.sleeptime,self.SendQueue,dispatcher)
   def SendBackOne(self,otask,n):
       dispatcher = (otask.ohost,otask.port)
       if otask not in self.sentback[dispatcher]:
          if self.verb: print dispatcher in self.dispatchers
          if dispatcher not in self.dispatchers: return
          cfs,queue = self.dispatcher[dispatcher]
          connector = cfs.keys()[n%len(cfs)][0]
          remote = self.dispatchers[dispatcher][connector]
          if self.verb: print "Sending back:",otask.taskid,otask
          if self.verb: print "Over port:",otask.port
          if self.verb: print "State:",dispatcher, connector.state
          result = otask.result
          presult,p = cPickle.dumps(result,2),1
          s = remote.callRemote("result",otask.taskid,presult,p)
          s.addCallback(lambda result: self.SentBackOne(otask))
   def SentBackOne(self,otask):
       dispatcher = (otask.ohost,otask.port)
       cfs,queue = self.dispatcher[dispatcher]
       self.queueback.pop(otask)
       self.goingback.pop(otask)
       self.sentback[dispatcher].setdefault(otask)
   def CloseOff(self,dispatcher):
       if dispatcher in self.dispatcher:
          cfs,queue = self.dispatcher[dispatcher]
          if len(cfs):
             print "Close Off Dispatcher!",dispatcher
             print "Pop remote!"
             print "Disconnect connectors:"
             d = defer.Deferred()
             factories = [cf[1] for cf in cfs]
             connectors = [cf[0] for cf in cfs]
             d.addCallback(lambda result: [factory.clientConnectionLost() for factory in factories])
             d.addCallback(lambda result: [connector.disconnect() for connector in connectors])
             d.addErrback(lambda reason: self.Problem(reason))
             d.callback(True)
             d = defer.Deferred()
             d.addCallback(lambda result: self.sentback.pop(dispatcher))
             d.addCallback(lambda result: self.dispatcher.pop(dispatcher))
             d.addCallback(lambda result: self.dispatchers.pop(dispatcher))
             d.addCallback(lambda result: sys.stdout.write("Popped for real\n"))
             d.addErrback(lambda reason: self.Problem(reason))
             reactor.callLater(self.sleeptime,d.callback,True)
#             return d
   def SendQueue(self,dispatcher,start=0):
       if dispatcher not in self.dispatcher:
          reactor.callLater(self.sleeptime,self.SendQueue,dispatcher)
          return
       cfs,queue = self.dispatcher[dispatcher]
       cr = [c for (c,f) in cfs if c in self.dispatchers[dispatcher] if c.state != "connected"]
       cd = [c for (c,f) in cfs if c in self.dispatchers[dispatcher] if c.state == "disconnected"]
       cs = [c.state for (c,f) in cfs if c in self.dispatchers[dispatcher]]
       if not start and (dispatcher in self.sentback and self.sentback[dispatcher]):
          if len(cr):
              print cs
              print len(self.sentback[dispatcher]), self.sentback[dispatcher].keys()[0].ntasks
          if len(self.sentback[dispatcher]) == self.sentback[dispatcher].keys()[0].ntasks:
#             if len(cd) < len(cs): reactor.callLater(1,self.SendQueue,dispatcher)
#             else: self.CloseOff(dispatcher)
#             self.CloseOff(dispatcher)
             return
       cr = [c for (c,f) in cfs if c in self.dispatchers[dispatcher] if c.state == "connected"]
#       if not queue or not cfs or len(cr) != len(cfs):
       if not cfs or len(cr) != len(cfs):
          reactor.callLater(self.sleeptime,self.SendQueue,dispatcher)
       elif queue:
          queue = [otask for otask in queue if otask not in self.sentback[dispatcher]]
          if queue:
             n = min([len(queue),len(cfs)])
             qtasks = [queue[i] for i in range(n)]
#             print "Send back",len(qtasks)
             self.SendBackThese(dispatcher,qtasks)
          reactor.callLater(self.sleeptime,self.SendQueue,dispatcher)
       else:
          reactor.callLater(self.sleeptime,self.SendQueue,dispatcher)


class HubAvatar(pb.Avatar):
    def __init__(self,hub):
        self.hub = hub
    def perspective_func(self,otask):
        task = TwistedTask()
        [setattr(task,attr,getattr(otask,attr)) for attr in otask.elements if hasattr(otask,attr)]
        if self.hub.verb: print "Got:",task
        self.hub.addTask(task)
        while not hasattr(task,"result") or not hasattr(task.result,"result") or \
               not isinstance(task.result,pb.RemoteReference):
            if self.hub.verb: print hasattr(task,"result")
            time.sleep( self.hub.sleeptime)
            if self.hub.verb: print "Waiting for results for",task
        if self.hub.verb: print hasattr(task,"result")
        return task.result

class TaskRealm:
    implements(IRealm)
    def __init__(self,dispatcher):
        self.dispatcher = dispatcher
    def requestAvatar(self, avatarId, mind, *interfaces):
        if pb.IPerspective in interfaces:
            self.receive = TaskResult( self.dispatcher)
            return pb.IPerspective, self.receive, lambda : None
        else:
            raise NotImplementedError("no interface")

class TaskResult(pb.Avatar):
   def __init__(self,dispatcher):
       self.dispatcher = dispatcher
   def perspective_received(self,taskid):
#       print "Hub received task",taskid,taskid in self.dispatcher.iq
#       print self.broker
#       sys.stdout.flush()
       self.dispatcher.queued.setdefault(taskid)
#       if taskid in self.dispatcher.iq:
#          self.dispatcher.queued.setdefault(taskid,self.dispatcher.iq[taskid])
#          print "in taskresult",self.dispatcher.queued.keys()
   def perspective_result(self,taskid,result,p):
       print "Got result for task",taskid
       if p: result = cPickle.loads(result)
       sys.stdout.flush()
       otask = None
       if taskid not in self.dispatcher.icompleted:
#          otask = self.dispatcher.queued[taskid]
#          otask.setResult(result)
          reactor.callLater(0.01,self.dispatcher.ClearTask,taskid,result)
          reactor.callFromThread(reactor.wakeUp)
          return taskid
       else:
          return -1

class HubDispatch:
   def __init__(self,tasks,hub,user=None,password=None,namespace=globals(),sleeptime=0.1,\
                verb=0,mport=0,restart=0,stayalive=0,running=0,throttle=2.0,nconnects=4):
       self.tasks = tasks
#       self.tasks = []
       ntasks = len(self.tasks)
       print "Number of tasks(%d)=%d"%(mport,ntasks)
       if ntasks == 1:
           print self.tasks
       self.term = len([t for t in self.tasks if "reactor.stop" in t.func])
       self.ntasks = ntasks
       self.throttle = throttle
       self.needinfo = True
       self.verb = verb
       self.init = 1
       self.stopping = False
       self.twaits = {}
       self.queued = {}
       self.iq = {}
       self.completed = {}
       self.icompleted = {}
       self.hub = hub
       self.user = user
       self.password = password
       self.nconnects = nconnects
       self.ready = False
       self.connectors = []
       self.remotes = [None for j in range(self.nconnects)]
       self.calls = {}
#       [self.calls.setdefault(j,None) or j in range(self.nconnects)]
       if self.user and self.password == None:
          self.password = getpass.getpass("%s's password:" % (self.user))
       self.sleeptime = sleeptime
       self.mport = mport
       n = "lo0"
       for i in netifaces.interfaces():
         if 2 in netifaces.ifaddresses(i) and netifaces.ifaddresses(i)[2][0].has_key("broadcast"):
            en = i
       en0 = netifaces.ifaddresses(en)
       self.ipaddr = en0[2][0]["addr"]
       self.rclose = False
       if namespace:
          self.namespace=namespace
          self.namespace["self%d"%(mport)] = self
       else:
          self.namespace = locals()
          self.namespace["self"] = self
       self.manhole = None
       self.reactor = reactor
       if ntasks and self.mport: self.Manhole()
       self.notdone = True
       self.reallydone = False
       self.alreadyrunning = reactor.running
       if reactor.running or running:
           self.stayalive = 1
       else:
           self.stayalive = stayalive
#       reactor.callFromThread(self.Start)
       if ntasks: self.Start()
       print "Reactor already running?",reactor.running
       if reactor.running:
#          while not hasattr(self,"connector") or self.connector.state != "connected":
#             time.sleep(self.sleeptime)
          self.Spin()
          if not self.ntasks: self.Stop()
       if not reactor.running:
          print "Starting the reactor!"
          reactor.run()
   def mehSpin(self,*args,**kw):
       self.Check()
       if self.notdone:
          reactor.callLater(self.sleeptime,self.mehSpin)
          return
       print "Spinning down!"
       print "ALL DONE (%d)!!!" % (self.mport)
   def Spin(self,*args,**kw):
       print "Spinning now!",self.notdone
       def SimpleSpin():
           while 1:
               if self.notdone or not self.reallydone:
                  self.Check()
                  time.sleep(self.sleeptime)
                  yield None
               else:
                  print "Spinning down!"
                  print "ALL DONE (%d)!!!" % (self.mport)
                  if self.manhole: print self.manhole,self.manhole.connected
                  reactorStatus(1)
                  break
       self.spin = task.cooperate(SimpleSpin())
   def StopManhole(self):
       if self.manhole.connected:
          self.manhole.stopListening()
          print "Manhole (%d), Stop Listening!!!" % (self.mport)
#          reactor.callFromThread( self.manhole.stopListening)
   def Check(self):
       self.notdone = not self.term and len(self.completed) < self.ntasks
   def Manhole(self):
       if self.user:
          user,password = self.user,self.password
       else:
          user,password = getpass.getuser(),""
       print "Open Manhole on port %d!!!" % (self.mport)
       self.manhole = AddManhole(user,password,namespace=self.namespace,port=self.mport)
       print "Manhole at",self.manhole
   def Problem(self,result):
       print dir(result)
       logging.err(result)
       return False
   def Start(self):
       self.connectors = []
       for n in range(self.nconnects):
           factory = MyPBClientFactory()
           print "Connecting to hub %s:%d" % (self.hub[0],self.hub[1])
           connector = reactor.connectTCP(self.hub[0],self.hub[1],factory)
           self.connectors.append(connector)
       self.Start2()
   def Start2(self):
       ready = [connector for connector in self.connectors if connector.state == "connected"]
       if len(ready) < self.nconnects:
          reactor.callLater(self.sleeptime,self.Start2)
          return
       self.ready = True
       [self.Start3(connector) for connector in self.connectors]
       reactor.callLater(self.sleeptime,self.Listening)
   def Start3(self,connector):
       if self.user:
          c = UsernamePassword(self.user,self.password)
       else:
          print "anonymous","anonymous"
          c = UsernamePassword("anonymous","anonymous")
       d = connector.factory.login(c)
       d.addCallback(lambda result: self.CheckConnected(result,connector))
#       if connector == self.connectors[0]: d.addCallback(lambda result: self.Dispatch())
       d.addErrback(lambda reason: self.Problem(reason))
#       d.callback(True)
#       reactor.callFromThread(reactor.wakeUp)
#       self.Spin()
#       return ds
#       print d
#       while not hasattr(d,"result") or self.connector.state != "connected":
#           time.sleep(self.sleeptime+1)
#           print d
#       self.GetInfo(d.result)
#   def IsConnected(self,result):
#       print "begin looping call"
#       print self.connector.state,hasattr(result,"callRemote")
#       self.cconnect = task.LoopingCall(self.CheckConnected,result)
#       self.cconnect.start(self.sleeptime)
##       d = threads.deferToThread(self.Spin)
##       d.addCallback(lambda x: self.Spin())
##       d.callback(True)
##       return d
   def CheckConnected(self,result,connector):
#       reactor.callFromThread(reactor.wakeUp)
#       if hasattr(result,"result"):
#          result = result.result
#       print connector,connector.state,hasattr(result,"callRemote")
       if connector.state == "connected" and hasattr(result,"callRemote"):
          print "GetInfo!",connector
#          reactor.callInThread(self.GetInfo,result)
#          reactor.callLater(self.sleeptime,self.Dispatch)
          return self.GetInfo(result,connector)
#          print "stopping?",self.connector.state
#          self.cconnect.stop()
   def NewInfo(self):
       if self.connectors[0].state == "connected" and hasattr(self.remotes[0],"callRemote"):
          d = self.remotes[0].callRemote("info")
          d.addCallback(lambda result: self.HaveInfo(result,simple=1))
          d.addErrback(self.Problem)
          return d
   def GetInfo(self,result,connector):
#       print "info",self.connector.state,result
       self.remotes[self.connectors.index(connector)] = result
       remote = self.remotes[self.connectors.index(connector)]
       d = remote.callRemote("info")
       d.addCallback(self.HaveInfo)
       d.addErrback(self.Problem)
#       reactor.callFromThread(reactor.wakeUp)
       return d
   def HaveInfo(self,result,simple=0):
       self.hubinfo = result
       while "numrunners" not in self.hubinfo:
#          reactor.callFromThread(reactor.wakeUp)
          print self.hubinfo
          time.sleep(self.time)
       self.numrunners = self.hubinfo["numrunners"]
       self.numrunning = self.hubinfo["numrunning"]
       self.runners = self.hubinfo["runners"]
       self.needinfo = False
#       print "Number of runners=",self.numrunners
       if simple: return
#       if self.tasks[0].func == "reactor.stop":
#         self.tasks = self.numrunners * self.tasks[:1]
       print "Number of runners in the Hub=",self.numrunners
#       print self.runners
       tfac = 10
       if hasattr(reactor.threadpool,"max"):
          reactor.suggestThreadPoolSize(max([5+tfac*self.numrunners,reactor.threadpool.max]))
          print reactor.threadpool.min,
          print reactor.threadpool.max,
          print reactor.threadpool.workers
          reactor.threadpool.adjustPoolsize(max([reactor.threadpool.workers,min([reactor.threadpool.max,20])]))
       else:
          reactor.suggestThreadPoolSize(5+tfac*self.numrunners)
          reactor.threadpool.adjustPoolsize(max([reactor.threadpool.workers,40]))
#       reactor.callLater(self.sleeptime,self.Listening)
   def CheckListen(self):
       if not hasattr(self,"listen") or not self.listen.getHost() or not hasattr(self,"numrunners"):
          print "No listening yet?"
          reactor.callLater(1.0,self.CheckListen)
          return
#       reactor.callFromThread(reactor.wakeUp)
       if self.tasks:
          self.Scan()
#             self.Spin()
   def Send(self):
       if not self.notdone: return
#       if not hasattr(self.remote,"callRemote"):
#       print len([r for r in self.remotes if r != None]), self.nconnects
       if len([r for r in self.remotes if r != None]) < self.nconnects:
          reactor.callLater(0.5,self.Send)
          return
       if self.tasks and self.needinfo: self.NewInfo()
       if not self.needinfo:
          if self.ntasks == 1 and len(self.tasks) == 1 and "reactor.stop" not in self.tasks[0].func and hasattr(self.tasks[0],"all"):
             print "Sending task to all stations!"
             stasks = [copy.copy(self.tasks[0]) for h in self.runners]
             [setattr(stask,"taskid",uuid.UUID(bytes=os.urandom(16),version=4).int) for h,stask in zip(self.runners,stasks)]
             [setattr(stask,"station",h) for h,stask in zip(self.runners,stasks)]
             print Set([getattr(stask,"station") for h,stask in zip(self.runners,stasks)])
             print "Number of stations=",len(Set([getattr(stask,"station") for h,stask in zip(self.runners,stasks)]))
             self.ntasks = len(stasks)
             self.tasks.extend(stasks)
             self.tasks.pop(0)
#          if len(self.tasks) == self.ntasks:
#             ngo = self.numrunners - len(self.queued)
#             ngo = min([self.throttle*self.numrunners,self.ntasks])
#          else:
          ngo = min([int(self.throttle*(self.numrunners-len(self.queued))),len(self.tasks)])
#             ngo = min([self.throttle*(self.numrunners-self.numrunning),self.ntasks])
#          ngo = min([self.throttle*(self.numrunners-len(self.queued)),self.ntasks])
#          ngo = min([self.throttle*self.numrunners,self.ntasks])
          busy = lambda t: t.taskid in self.queued or t.taskid in self.iq              
          stasks = [t for t in self.tasks[:ngo] if not busy(t)]
          if stasks:
              if self.verb: print "Going to send %d tasks" % (len(stasks))
              [self.tasks.remove(stask) for stask in stasks]
              [self.iq.setdefault(otask.taskid,otask) for otask in stasks]
#              reactor.callFromThread(reactor.wakeUp)
          self.needinfo = True
       reactor.callLater(self.sleeptime,self.Send)
   def Scan(self):
       self.nr = 0
       reactor.callLater(self.sleeptime,self.Send)
#       self.ws = task.LoopingCall(self.Send)
#       self.ws.start(self.sleeptime)
       self.scancheck = task.LoopingCall(self.ScanCheck)
       self.scancheck.start(self.sleeptime)
       reactor.callLater(0.1,self.WaitForQueue)
   def ScanCheck(self):
#       reactor.callFromThread(reactor.wakeUp)
       ready = len([r for r in self.remotes if hasattr(r,"callRemote")]) == self.nconnects
       if self.init and ready:
          self.init = 0
          print "START DISPATCH"
          reactor.callLater(self.sleeptime,self.Dispatch)
       if self.tasks:
          self.nr += 1
          if self.verb and not (self.nr%200):
             print self.Status()
          return 
#       if self.ws.running:
#          self.ws.stop()
#          print "stopping looping"
#       reactor.callFromThread(reactor.wakeUp)
       self.wqcount = 0
#       reactor.callLater(0.1,self.WaitForQueue)
#       self.wq = task.LoopingCall(self.WaitForQueue)
#       self.wq.start(self.sleeptime)
       if self.scancheck.running:
          self.scancheck.stop()
   def WaitForQueue(self):
       print "Waiting",self.Status()
       goback = False
       if self.stopping:
          goback = True
          return
#       if [q for q in self.queued if not q.done and "reactor.stop" not in q.func]:
#       if self.iq or self.queued:
       if self.notdone:
#               [q for q in self.queued if "reactor.stop" not in q.func] or \
#               [q for q in self.iq if "reactor.stop" not in q.func]:
          self.Check()
          reactor.callLater(1.0,self.WaitForQueue)
          goback = True
          return
       hr = len([r for r in self.remotes if r != None]) == self.nconnects
       hc = len([connector for connector in self.connectors if connector.state == "connected"]) #== self.nconnects
       hca = len([connector for connector in self.connectors if connector.state == "connected"]) == self.nconnects
       print "rcd",hr,hc,self.rclose
       if not self.term and not goback and (hr and hc and self.rclose==False):
          print "REMOTE CLOSE!",hca,self.rclose==False,
          print (hca and self.rclose==False)
          if (hca and self.rclose==False):
             self.rclose = True
             reactor.callLater(self.sleeptime,self.RemoteCloseOffDispatchers)
             reactor.callLater(0.1,self.WaitForQueue)
             goback = True
             return
#       print "disc"
#       print [connector.state for connector in self.connectors]
       hd = [connector for connector in self.connectors if connector.state != "disconnected"]
       print hd,self.term
       if not self.term and hd and not goback:
          print "GO BACK!!!"
          reactor.callLater(0.1,self.WaitForQueue)
          goback = True
          return
       hs = [connector.state for connector in self.connectors]
       print hs
       print self.listen,
       print self.listen.disconnected,
       print self.listen.disconnecting
       if not self.term and not goback and (not self.listen.disconnected or self.listen.disconnecting):
          print "GO BACK?"
          reactor.callLater(0.1,self.WaitForQueue)
          goback = True
       if self.manhole: print "man",self.manhole.connected,self.manhole.disconnected,self.manhole.disconnecting
       if not self.term and not goback and (self.manhole and (not hasattr(self.manhole,"connected") or self.manhole.connected or not self.manhole.disconnected) and not self.manhole.disconnecting):
          if self.manhole.connected:
              print "Manhole (%d), Stop Listening?" % (self.mport)
              self.StopManhole()
          reactor.callLater(0.1,self.WaitForQueue)
          goback = True
          return
       if goback:
          print "WHAT AM I DOING HERE?"
       else:
          print self.queued
#          return
#          if 0 and hasattr(self,"listen") and self.rclose:
#                d = defer.Deferred()
#                d.addCallback(lambda result: self.listen.stopListening())
#                d.addCallback(lambda result: self.listen.factory.protocol.loseConnection())
#                d.callback(True)
#          reactor.callLater(0.01,reactor.stop)
#          if [q for q in self.queued if not q.done]: return
#          reactor.callFromThread(reactor.wakeUp)
          print "Queue complete. Can stop now!"
          self.stopping = True
#          self.wq.stop()
          reactor.callLater(self.sleeptime,self.Stop)
#          self.Stop()
   def Stop(self):
       print "Time to stop!"
#       reactor.callFromThread(reactor.wakeUp)
#       self.Check()
#       if hasattr(self,"listen"):
#          print self.listen.connected, self.listen.disconnecting, self.listen.disconnected
#          if not self.listen.disconnected and self.notdone:
#             reactor.callLater(0.1,self.Stop)
#             return
       [reactor.callLater(self.sleeptime,t.CleanUp) for t in self.completed]
       if self.stayalive:
          print "let's see if we can keep the reactor alive"
       elif reactor.running:
          print "Stopping!"
          reactor.callFromThread(reactor.disconnectAll)
          reactor.callLater(0.01,reactor.callFromThread,reactor.stop)
       self.reallydone = True
#       reactorStatus(1)
   def WaitForDisconnect(self):
       if self.connectors[0].state == "disconnected":
           reactor.callFromThread(reactor.stop)
   def Listening(self,otask=None):
       realm = TaskRealm(self)
       portal = Portal(realm)
       checker = InMemoryUsernamePasswordDatabaseDontUse()
       if self.user:
          checker.addUser(self.user,self.password)
       else:
          c = checker.addUser("anonymous","anonymous")
       portal.registerChecker(checker)
       broker = pb.PBServerFactory( portal)
       listen = reactor.listenTCP(0,broker)
       listen.startListening()
#       reactor.callFromThread(reactor.wakeUp)
       if otask:
          otask.listen = listen
          otask.pb = broker
          otask.ohost = self.ipaddr
          otask.port = otask.listen.getHost().port
          if self.verb: print "Listening on", self.ipaddr, otask.listen.getHost().port
       else:
          self.listen = listen
          self.pb = broker
          print "Listening on", self.ipaddr, self.listen.getHost().port
          reactor.callLater(self.sleeptime,self.CheckListen)
#   @defer.inlineCallbacks
   def Dispatch(self):
#       ngo = min([self.throttle*(self.numrunners-len(self.queued)),len(self.iq)])
       if self.reallydone: return
       ngo = min([self.throttle*self.numrunners,len(self.iq)])
#       ngo = (self.numrunners-len(self.queued)) > (self.throttle-1)*self.numrunners
#       print self.numrunners-len(self.queued),(self.throttle-1)*self.numrunners,ngo
#       print self.iq
       if self.iq.keys() and ngo:
           jr = [j for j in range(self.nconnects) if j not in self.calls]
           if not jr: 
              reactor.callLater(self.sleeptime,self.Dispatch)
              return
           if jr: jr = jr[0]
           self.calls[jr] = None
           oid = self.iq.keys()[0]
           if oid in self.iq and oid not in self.queued:
              otask = self.iq.pop(oid)
              if hasattr(self,"listen") and not hasattr(otask,"listen"):
                 g = self.listen.getHost()
                 otask.ohost = self.ipaddr
                 otask.port = g.port
                 otask.ntasks = self.ntasks
              elif "reactor.stop" not in otask.func:
                 otask.ntasks = 1
                 self.Listening(otask)
              ctask = CopyTask()
              [setattr(ctask,attr,getattr(otask,attr)) for attr in otask.elements if hasattr(otask,attr)]
#              jr = randint(0,self.nconnects-1)
              if self.verb: print "SENDING %d WITH %d" % (otask.taskid,jr)
              d = self.remotes[jr].callRemote("task",ctask)
              self.calls[jr] = d
#              d = defer.Deferred()
#              d.addCallback(lambda result: EvalTask(otask))
#              d.addCallback(lambda result: self.Dispatch())
              d.addCallback(lambda result: self.GetResult(result,otask))
              if "reactor.stop" not in otask.func:
                  reactor.callLater(self.sleeptime,self.Dispatch)
#                  d.addCallback(lambda result: reactor.callLater(self.sleeptime,self.Dispatch))
              d.addCallback(lambda result: self.calls.pop(jr))
              d.addErrback(lambda reason: reason.value)
#              yield
#              reactor.callLater(self.sleeptime,self.Dispatch)
       elif self.notdone:
#          print "Go again!",self.notdone,self.iq,len(self.tasks),self.ntasks,len(self.completed)
#          time.sleep(self.sleeptime)
          reactor.callLater(self.sleeptime,self.Dispatch)
       else:
          reactor.callLater(self.sleeptime,self.Dispatch)
   def GetResult(self,result,otask):
       if self.verb: print "Hub received",otask.taskid
       if "reactor.stop" not in otask.func:
           self.queued.setdefault(otask.taskid,otask)
       if "reactor.stop" in otask.func:
#          self.queued.pop(otask)
#          self.iq.pop(otask.taskid)
          print "Disconnect!"
          self.connector.disconnect()
   def WaitForTask(self,otask):
       if not otask.done: return
       if hasattr(otask,"listen"):
          otask.listen.stopListening()
#          reactor.callFromThread(otask.listen.stopListening)
#       reactor.callFromThread(self.twaits[otask].stop)
#       reactor.callInThread(self.ClearTask,otask)
   def ClearTask(self,taskid,result):
       if self.verb:
          print "in cleartask",self.queued.keys(),
          print taskid in self.queued
       if taskid not in self.queued:
          reactor.callLater(0.01,self.ClearTask,taskid,result)
          return
       otask = self.queued[taskid]
       otask.setResult(result)
       if self.verb:
           print "Got the result for task",otask.taskid
       if otask.done:
          otask.longResult()
          if hasattr(otask,"uR"):
#             reactor.callLater(0.1,otask.uR, *otask.uRargs, **otask.uRkw)
             otask.uR(*otask.uRargs, **otask.uRkw)
          if hasattr(otask,"listen"):
             otask.listen.stopListening()
          self.completed.setdefault(otask)
          self.icompleted.setdefault(otask.taskid,otask)
#          if otask.taskid in self.iq: self.iq.pop(otask.taskid)
          if otask.taskid in self.queued: self.queued.pop(otask.taskid)
#       reactor.callFromThread(reactor.wakeUp)
   def Status(self):
       if hasattr(self,"manhole") and self.manhole and self.manhole.connected:
          return self.notdone,self.reallydone,len(self.completed),self.ntasks,len(self.queued),len(self.iq),self.connectors[0].state,self.manhole.getHost().port
       else:
          return self.notdone,self.reallydone,len(self.completed),self.ntasks,len(self.queued),len(self.iq),self.connectors[0].state
   def Inquire(self):
       oids = self.iq.keys() + self.queued.keys()
       jr = randint(0,self.nconnects-1)
       d = self.remotes[jr].callRemote("inquire",oids)
       d.addCallback(lambda result: self.SetInq(result))
       d.addErrback(self.Problem)
       return d
   def RemoteCloseOffDispatchers(self):
       print self.listen
       if self.completed and self.connectors[0].state == "connected":
          self.rclose=True
          print "Remote CloseOff!"
          g = self.listen.getHost()
          ohost = self.ipaddr
          port = g.port

          d = defer.Deferred()
          d.addCallback(lambda result: self.remotes[0].callRemote("closeoff",(ohost,port)))
          d.addCallback(lambda result: self.listen.stopListening())
          d.addCallback(lambda result: self.connectors[0].disconnect())
          d.addErrback(lambda reason: self.Problem(reason))
          reactor.callLater(0.1,d.callback,True)
          for j in range(1,self.nconnects):
              print j
              self.connectors[j].disconnect()
#              d.addCallback(lambda result: self.remotes[j].callRemote("closeoff",(ohost,port)))
#              d.addCallback(lambda result: self.connectors[j].disconnect())
#          d.addErrback(lambda reason: self.Problem(reason))
#          d.callback(True)
#          d = defer.Deferred()
#          for j in range(self.nconnects):
##              d.addCallback(lambda result: self.connectors[j].disconnect())
#              self.connectors[j].disconnect()
##          d.callback(True)
#          d.addCallback(lambda result: self.factory.clientConnectionLost())
#          d.addErrback(lambda reason: self.Problem(reason))
#          d.callback(True)
#          d = defer.Deferred()
#          d.addCallback(lambda result: self.listen.stopListening())
#          d.addErrback(lambda reason: self.Problem(reason))
#          d.callback(True)
          self.dclose = False
   def SetInq(self,result):
       self.inquiry = result
       return self.inquiry
   def Flush(self):
       if self.connector.state == "disconnected":
          d = self.Start()
          d.addCallback(lambda x: self.Dispatch())
          d.addErrback(self.Problem)
       else:
          reactor.callLater(self.sleeptime,self.Dispatch)
   def Fix(self):
       o0 = self.runners
       d = self.NewInfo()
       d.addCallback(lambda result: self.Fix2(o0))
   def Fix2(self,o0):
       o2 = [h for h in self.runners if h not in o0]
       o1 = [h for h in o0 if h not in self.runners]
       ts = self.queued.values()
       for t,h1,h2 in zip(ts,o1,o2):
           t.station = h2
           self.iq.setdefault(t.taskid,t)
   def Resend(self):
       [[self.iq.setdefault(tid,t), self.queued.pop(tid)] for tid,t in self.queued.items()]


def AddManhole(user,password,namespace,port,now=0,simple=0):
    if simple:
       f = ShellFactory()
    else:
       checker = InMemoryUsernamePasswordDatabaseDontUse()
       checker.addUser(user,password)
       rlm = TerminalRealm()
       rlm.chainedProtocolFactory = lambda: insults.ServerProtocol( Manhole,namespace=namespace)
       ptl = Portal(rlm, [checker])
       f = ConchFactory(ptl)
       if twv.major >= 17:
          path = os.path.expanduser('~/.ssh/id_rsa') 
          keyDir='ssh-keys/'
          keyName="id_rsa.pub"
          keyLocation = filepath.FilePath(keyDir).child(keyName)
          keySize = 4096
          sshKey = keys._getPersistentRSAKey(keyLocation,keySize)
          f.publicKeys[b"ssh-rsa"] = sshKey
          f.privateKeys[b"ssh-rsa"] = sshKey
    r = reactor.listenTCP(port, f)
    return r

class SpawnTask(pb.Avatar):
   def __init__(self,add_modules=[],add_fmodules=[],IMPORTS={}):
      self.IMPORTS = IMPORTS
      print self.IMPORTS.keys()
      self.pid = os.getpid()
      self.added = []
      self.fadded = []
      self.modules = []
      self.fmodules = []
      if add_modules.split(","): self.modules += add_modules.split(",")
      if add_fmodules.split(","): self.fmodules += add_fmodules.split(",")
   def perspective_lmod(self,smod):
         lmod = cPickle.loads(smod)
         os.chdir(lmod["path"])
         f = open(lmod["name"],"w")
         f.write(lmod["data"])
         f.close()
   def perspective_kill(self,sig=9):
      if hasattr(self,"value") and isinstance(self.value,verbsh) and self.value.perf.poll() == None:
         if sig == None: return self.value.perf.pid
         else: return os.kill(self.value.perf.pid,sig)
      else: return os.kill(self.pid,sig)
   def perspective_load(self):
      loadavg = os.getloadavg()
      return loadavg
   def perspective_task(self,otask):
      self.tstart = time.time()
      self.taskid = otask.taskid
      self.current = otask
      self.path = otask.path
      print "Changing current working directory to %s." % (self.path)
      sys.stdout.flush()
      os.chdir(self.path)
      sys.path = orig_path + [self.path]
      sys.stdout.flush()
      if hasattr(otask,"env") and not isinstance(otask.env,NoneType):
         newenviron = cPickle.loads(otask.env)
         for item in newenviron:
             print "Loading new environment variable %s = %s" % (item,newenviron[item])
             os.environ[item] = newenviron[item]
      if self.modules:
         [twisted_import(m,IMPORTS=self.IMPORTS) for m in self.modules if m]
      if self.fmodules:
         [twisted_import(m,"*",IMPORTS=self.IMPORTS) for m in self.fmodules if m]
      if hasattr(otask,"modules"):
         [twisted_import(m,IMPORTS=self.IMPORTS) for m in otask.modules if m]
      if hasattr(otask,"fmodules"):
         [twisted_import(m,"*",IMPORTS=self.IMPORTS) for m in otask.fmodules if m]
      self.defer = threads.deferToThread( self.subperspective_task,otask)
#      self.defer = defer.Deferred()
#      self.defer.addCallback(lambda result: self.subperspective_task(otask))
      self.defer.addCallback(lambda result: self.subperspective_cPickle(otask.result))
      self.defer.addCallback(lambda result: (os.getloadavg(),otask.taskid,result,True,True))
      self.defer.addErrback(lambda result: (os.getloadavg(),otask.taskid,result.getTraceback(),False,False))
      self.defer.addCallback(lambda result: [(not hasattr(otask,"cleanup") and 1 or eval(getattr(otask,"cleanup"))()),\
              result][1])
      self.defer.addCallback(lambda result: [(not hasattr(otask,"value") and 1 or delattr(otask,"cleanup")),\
              result][1])
#      self.defer.callback(True)
      return self.defer
   def subperspective_task(self,otask):
      tstart = time.time()
      print "Got",otask, type(otask.func)
      sys.stdout.flush()
      loadavg = os.getloadavg()
      if type(otask.func) is DictionaryType:
         T = TransportFunction()
         func = otask.func[ otask.func.keys()[0]]
         name,func = T.UnmarshalFunction(func,globals())
      else:
         func = otask.func
      taskid = otask.taskid
      sys.stdout.write("Function=%s\n" % (func))
      sys.stdout.flush()
      print "Evaluating now..."
      sys.stdout.flush()
      self.value = EvalTask(otask)
      if isinstance(self.value,verbsh):
         while self.value.perf.poll() == None:
           time.sleep(0.01)
         value = self.value.perf.poll()
      else:
         value = self.value
      return value
   def subperspective_cPickle(self,value):
      value = cPickle.dumps(value,2)
      if len(value) > 16384: 
         d = "%s/.tasks" %(self.path)
         if not os.path.exists(d): os.mkdir(d)
         a = open("%s/.tasks/.%dresult.dat" %(self.path,self.taskid),"wb")
         a.write(value)
         a.close()
         value = ("File",a.name)
         print "Dumping result:",value
         value = cPickle.dumps(value,2)
      sys.stdout.write("Task %r completed.\n" % (self.taskid))
      sys.stdout.flush()
      self.tend = time.time()
      return value

class FunctionRealm:
    implements(IRealm)
    def __init__(self,modules,fmodules):
       self.modules = modules
       self.fmodules = fmodules
       self.spawn = SpawnTask(self.modules,self.fmodules,IMPORTS)
    def requestAvatar(self, avatarId, mind, *interfaces):
        if pb.IPerspective in interfaces:
            return pb.IPerspective, self.spawn, lambda : None
        else:
            raise NotImplementedError("no interface")

def brint(o):
   print str(type(o))

class WatchTask(pb.Avatar):
   def __init__(self,realm):
#      self.tr = tracker.SummaryTracker()
      self.realm = realm
      self.modules = realm.modules
      self.fmodules = realm.fmodules
      self.spawn = SpawnTask(self.modules,self.fmodules,IMPORTS)
   def perspective_task(self,otask):
      print "RUNNING IN THE URGENT PATH!!!"
      return self.spawn.perspective_task(otask)
   def perspective_kill(self,sig=9):
     task = self.realm.spawn
     if hasattr(task,"value") and isinstance(task.value,verbsh) and task.value.perf.poll() == None:
        usepid = task.value.pid
     else:
        usepid = task.pid
     if sig == None: return usepid
     else: return os.kill(usepid,sig)
   def perspective_elapsed(self):
     taskid = getattr(self.realm.spawn,"taskid",None)
     now = time.time()
     elapse = now - getattr(self.realm.spawn,"tstart",now)
     return (taskid,elapse)
   def perspective_diff(self):
     d = tr.print_diff()
     return d
   def perspective_load(self):
     loadavg = os.getloadavg()
     return loadavg
   def perspective_stop(self):
#     reactor.callLater(1,reactor.stop)
#     reactor.callLater(1,reactor.callFromThread,reactor.stop)
     reactor.callFromThread(reactor.stop)
#     return True

class WatchRealm:
    implements(IRealm)
    def __init__(self,realm):
       self.watch = WatchTask(realm)
    def requestAvatar(self, avatarId, mind, *interfaces):
        if pb.IPerspective in interfaces:
            return pb.IPerspective, self.watch, lambda : None
        else:
            raise NotImplementedError("no interface")


def CleanMachines(machines,uid=getpass.getuser()):
    machines = list(sets.Set(machines))
    return TwistedHub([],verb=0,clean=1,wait=1,norun=1,machines=machines,uid=uid,namespace=globals(),nice=0)

def reactorStatus(verb=0):
    funcs = [p1.func for p1 in reactor._pendingTimedCalls if hasattr(p1,"func")]
    unfin = reactor.threadpool.q.unfinished_tasks
    npend = len(reactor._pendingTimedCalls)
    print "Unfinished Tasks:",unfin
    print "Number of pending calls:",npend
    print "Number of readers:",len(reactor.getReaders())
    if verb:
       print reactor.getReaders()
    print "Number of writers:",len(reactor.getWriters())
    if verb:
       print reactor.getWriters()
    if funcs:
       print "Pending function calls:"
       for i,func in enumerate(funcs):
           if hasattr(func,"func_name"): title = func.func_name
           elif hasattr(func,"__name__"): title = func.__name__
           else: title = func
           imc = getattr(func,"im_class",None)
           print "   %5d %r %r" % (1+i,title,imc)
    else:
       print "No pending function calls."


